<?php

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.model');

class CCauthModelChgpas extends JModelItem //change component
{
	//set common functions set in the home model
	public function sanitizeInput($data){
	return $this->getInstance('Home', 'CCauthModel')->sanitizeInput($data);
	}

//validate the user first
	public function getAuth($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$skey = $jinput->get('skey','','string'); //default page is empty.
		$uscode = $jinput->get('uscode','','string'); //default page is empty.
		$priv_req = 'authall'; //required privilege
				
		//validation process
		$skey = $this->sanitizeInput($skey);
			
		// query if found
		function getUsid($skey, $uscode, $priv_req) {

				$db = JFactory::getDbo();
				$query = $db->getQuery(true);
				$query->select($db->quoteName('a.uscode')); //change field
				$query->from($db->quoteName('#__ccauthsession', 'a')); // change when change table
				$query->join('RIGHT', $db->quoteName('#__ccauthlist', 'b') . ' ON (' . $db->quoteName('a.uscode') . ' = ' . $db->quoteName('b.uscode') . ')');
				// here is the matching criteria:  
				$query->where($db->quoteName('passwrd') . ' = '. $db->quote($skey));
				$query->where($db->quoteName('b.priv') . ' = '. $db->quote($priv_req));//this is the privilege
				$query->where($db->quoteName('b.uscode') . ' = '. $db->quote($uscode));//this is the privilege
				$db->setQuery($query);
				$results = $db->loadResult(); //single data query
				
				return $results;
		}
			
		$check = getUsid($skey, $uscode, $priv_req);
		
		if($check!=""){
			$valid = 1;
			}
			else {
			$valid = 0;
			}
		return $valid;
	}
	
	
//prepare the sessions and user-ID
	
	public function getSkey($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('skey','','string'); //default page is empty.
		return $this->sanitizeInput($result);
	}
	
	public function getUscode($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('uscode','','string'); //default page is empty.
		return $this->sanitizeInput($result);		
	}
//prepare the sessions and user-ID - end
	
}
?>