<?php

defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.model');

class CCjournalModelNew_Item extends JModelItem
{
	//to get back the id of article want to be commented.
	
/*************************  COMMON FUNCTIONS *****************************/

	public function sanitizeInput($input){
		$input = trim($input);
		$input = stripslashes($input);
		$input = htmlspecialchars($input);
		return $input;
	}
		

/********************  AUTHORITY CHECK FUNCTIONS *************************/


	public function getAuthority() 
	{	
		$skey 	= $this->getSkey(); 
		$uscode = $this->getUscode(); 
		$priv_req = 'authall'; //required privilege
		$check = $this->getInstance('Home', 'CCjournalModel')->home_check_priv($skey, $uscode, $priv_req); // this refer function in the home model.
		return $check;
	}

/*****************  GETTING THE DATA TO DETERMINE HOW THE PAGE LOOKS *******************/
	
	public function getSkey($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('skey','','string'); //default page is empty.
		$result = $this->sanitizeInput($result);
		return $result;		
	}
	
	public function getUscode($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('uscode','','string'); //default page is empty.
		$result = $this->sanitizeInput($result);
		return $result;		
	}
/*old
	public function getAuth($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$skey = $jinput->get('skey','','string'); //default page is empty.
		$uscode = $jinput->get('uscode','','string'); //default page is empty.
		$priv_req = 'accnew'; //required privilege
				
		//validation process
		$skey = $this->sanitizeInput($skey);
			
		// query if found
			function getUsid($passwd, $uscode, $priv_req) {
	
					$db = JFactory::getDbo();
					$query = $db->getQuery(true);
					$query->select($db->quoteName('a.uscode')); //change field
					$query->from($db->quoteName('#__ccauthsession', 'a')); // change when change table
					$query->join('RIGHT', $db->quoteName('#__ccauthlist', 'b') . ' ON (' . $db->quoteName('a.uscode') . ' = ' . $db->quoteName('b.uscode') . ')');
					// here is the matching criteria:  
					$query->where($db->quoteName('passwrd') . ' = '. $db->quote($passwd));
					$query->where($db->quoteName('b.priv') . ' = '. $db->quote($priv_req));//this is the privilege
					$query->where($db->quoteName('b.uscode') . ' = '. $db->quote($uscode));//this is the privilege
					$db->setQuery($query);
					$results = $db->loadResult(); //single data query
					
					return $results;
			}
			
		$check = getUsid($skey, $uscode, $priv_req);
		
		if($check!=""){
			$valid = 1;
			}
			else {
			$valid = 0;
			}
			
		return $valid;
	}

	//to get back the id of article want to be commented.
	public function sanitizeInput($input){
	$input = trim($input);
	$input = stripslashes($input);
	$input = htmlspecialchars($input);
	return $input;
	}

	public function getSkey($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('skey','','string'); //default page is empty.
		//validation process
		$result = $this->sanitizeInput($result);
		return $result;		
	}
	*/
	
/*****************  GETTING DATA FOR FORM VALIDATIONS *******************/
	function getGlid($id=1)
	{
		
		// This function is to get eligible items as arrays.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName(array('glid','glname'))); //change field
		$query->from($db->quoteName('#__ccworldgl')); // change when change table
		// here is the matching criteria:  
		$query->where($db->quoteName('status') . ' = '. $db->quote('1'));
		 
		$db->setQuery($query);
		$results = $db->loadRowList();
		
		return $results;
	}

}
?>