<?php
/**
 *  
 * support: sorting configured in menu items.
 * numbering on item, numbering on page, max item per page, max paging per page.
 */
 
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

class CCpembelianModelPur_rec_detail extends JModelItem
{
	protected $messages;

/*
	public function getTable($type = 'CCinve', $prefix = 'CcInveTable', $config = array()) //cc notes: prefix can be changed consistent with file ccworld content. Type should consistent with both class name and file name.
	{
		return JTable::getInstance($type, $prefix, $config);
	}
*/ 

	public function sanitizeInput($input){
		$input = trim($input);
		$input = stripslashes($input);
		$input = htmlspecialchars($input);
		return $input;
		}
	
	public function validateCompare($data, $validData){
		//This function to compare a string against valid data in arrays.
		$data = $this->sanitizeInput($data);
		//set default first
		$result = $validData[0];// set default result to first valid data if not found
		//compare, if found override result
			foreach ($validData as $testdata){
				if($testdata == $data ){				
				$result = $data; //override result
				}
			}
		return $result;
		}

//function to validate user 
/*
	public function getUsid($passwd, $uscode, $priv_req) {
			$db = JFactory::getDbo();
			$query = $db->getQuery(true);
			$query->select($db->quoteName('a.uscode')); //change field
			$query->from($db->quoteName('#__ccauthsession', 'a')); // change when change table
			$query->join('RIGHT', $db->quoteName('#__ccauthlist', 'b') . ' ON (' . $db->quoteName('a.uscode') . ' = ' . $db->quoteName('b.uscode') . ')');
			// here is the matching criteria:  
			$query->where($db->quoteName('passwrd') . ' = '. $db->quote($passwd));
			$query->where($db->quoteName('b.priv') . ' = '. $db->quote($priv_req));//this is the privilege
			$query->where($db->quoteName('b.uscode') . ' = '. $db->quote($uscode));//this is the privilege

			$db->setQuery($query);
			$results = $db->loadResult(); //single data query
			
			return $results;
	}
*/

//function to check if user has access to this view.
	public function getAuth($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$skey = $jinput->get('skey','','string'); //default page is empty.
		$uscode = $jinput->get('uscode','','string'); //default page is empty.
		$priv_req = 'konfirmasi'; //required privilege
				
		//validation process
		$skey = $this->sanitizeInput($skey);
			
		// query if found

			
		//$check = getUsid($skey, $uscode, $priv_req);
		$check = $this->getUsid($skey, $uscode, $priv_req);
		
		if($check!=""){
			$valid = 1;
			}
			else {
			$valid = 0;
			}
			
		return $valid;
	}
//prepare the sessions, user codes, salesID and month for Menus in the default page.
	
	public function getSkey($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('skey','','string'); //default page is empty.
		//validation process
		$result = $this->sanitizeInput($result);
		return $result;		
	}
	
	public function getUscode($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('uscode','','string'); //default page is empty.
		//validation process
		$result = $this->sanitizeInput($result);
		return $result;		
	}
	
	public function getUsid($id = 1) {		//authority check
		//$usid = $this->getSomeRows('usid', '#__ccauthsession', 'passwrd',$this->getUscode);
		//validate if found
		
		//return $result;	
		$skey = $this->getSkey();
		//$uscode = "e2ef7b61bb37ac19c020f5100ed6df202bec0424";
		$db = JFactory::getDbo();
		$query = $db
		->getQuery(true)
		->select('usid')
		->from($db->quoteName('#__ccauthsession')) // change when change table
		->where($db->quoteName('passwrd') . ' = '.$db->quote($skey));
		
		$db->setQuery($query);
		$result = $db->loadResult();
		
		if(empty($skey)){
			return "";
		}
		else{
			return $result;
		}		
	}
	
	public function getPurid($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('purid','','string'); //default page is empty.
		//validation process
		$result = $this->sanitizeInput($result);
		return $result;		
	}
	
	public function getMonth($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('month','','string'); //default page is empty.
		//validation process
		$result = $this->sanitizeInput($result);
		return $result;		
	}
	
	
//Prepare some parameters to display main messages / list of messages.
	public function getPage($id = 1) {		
		$jinput = JFACTORY::getApplication()->input;
		$page = $jinput->get('page',1,'int'); //default page is 1.
				
		//validation process
		$page = $this->sanitizeInput($page);
		$itemscount = $this->getItemscount();
		$itemsperpage = $this->getItemsperpage();
			
		// get from xml
		$maxpage = round(($itemscount / $itemsperpage) + 0.5,0,PHP_ROUND_HALF_DOWN);
		
		if($page < 1){$page = 1;}//default page is 1.
		if($page > $maxpage){$page = $maxpage;} //max is maxpage
		return $page;
	}

	
//get current maximum paging per screen.
	public function getMaxpaging($id = 1){
		// get from xml
		$app = JFactory::getApplication();
		$params = $app->getParams();
				
		$result = $params->get('maxpage', 10); //if not set, then 10 as default
		return $result;			
	}

//count number of messages / items matching criteria, so it can be calculated for paging.
	public function getItemscount($id = 1) {
		// This function is to count eligible items. Results are returned to get the max page.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		
		$months = $this->getMonth();

		$db = JFactory::getDbo();
		$query = $db->getQuery(true);

		// how to use
		/*
		$fields = array, example: $fields = array('a.*', 'b.username', 'b.name');
		$table1 and table2 = array, table and assigned variable, example $table = ('#__content', 'a');
		$conditions = [0] set the table and operator, [1] tested values, example $conditions = array('b.username', ' = 2');
		*/
		$query->select('a.*','b.name');
		$query->from($db->quoteName('#__ccsales','a'));
		
		$query->join('INNER', $db->quoteName('#__cccust','b') . ' ON ' . $db->quoteName('a.cuid') . ' = ' . $db->quoteName('b.cuid'));
		
		$query->where($db->quoteName('a.published') . ' > ' . $db->quote('0'));
		
		$query->where($db->quoteName('a.samonth') . ' = ' . $db->quote($months) );
		$query->order($db->quoteName('a.salesid'). ' ASC');
		
		$db->setQuery($query);

		// Load the results as a list of stdClass objects (see later for more options on retrieving data).
		$results = $db->loadObjectList();
		
		$itemscount = count($results);
		
	// jadul
	/*
		$query->select($db->quoteName('a.uscode'));
		$query->select($db->quoteName('a.priv'));
		$query->select($db->quoteName('b.link_to_menu'));
		$query->select($db->quoteName('b.menu'));
		$query->select($db->quoteName('b.menu_desc'));
		$query->from($db->quoteName('#__ccauthlist', 'a')); // change when change table
		$query->join('LEFT', $db->quoteName('#__ccauthmenu', 'b') . ' ON (' . $db->quoteName('a.priv') . ' = ' . $db->quoteName('b.priv') . ')');
		$query->where($db->quoteName('uscode') . ' = '. $db->quote($uscode));
		$query->where($db->quoteName('b.link_to_menu') . ' != ""');
		
		$db->setQuery($query);
			 
		$results = $db->loadObjectList();	
		$itemscount = count($results);
		*/
	//	jadul
		return $itemscount;
		}
	
		
//get numbers of messages/items shown per page.
	public function getItemsperpage(){

		// get from xml if database is not set
		$app = JFactory::getApplication();
		$params = $app->getParams();
				
		$result = $params->get('maxitem',10); //if not set, 10 as default
		
		return $result;
		}

// now get the comments to be displayed, according to matching criteria.
	
	public function getOrdering($id = 1) {	
			$app = JFactory::getApplication();
			$params = $app->getParams();
			$order_default = $app->input->get('limit', $params->get('orderby_sec', 'inid'), 'uint');
			
			//new: override if set by user. dont forget to validate
			$jinput = JFACTORY::getApplication()->input;
			$order_type = $jinput->get('orderby',$order_default); //default get parameter

			$order_submit = $this->sanitizeInput($jinput->get('ordering_submit')); 
			if (isset($order_submit))
			{
			$order_type = $order_submit;
			}
			$validDataOrdering = ['id','rid','name','rname'];
			
			$order_type = $this->validateCompare($order_type, $validDataOrdering);
						
			return $order_type;
		}
		
	public function selectRows($fields, $table, $conditions, $orders, $joints1, $table2, $joints2){
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);

		// how to use
		/*
		$fields = array, example: $fields = array('a.*', 'b.username', 'b.name');
		$table1 and table2 = array, table and assigned variable, example $table = ('#__content', 'a');
		$conditions = [0] set the table and operator, [1] tested values, example $conditions = array('b.username', ' = 2');
		*/
		$query->select($fields);
		$query->from($db->quoteName($table));
		
		if(isset($joints1)){
		$query->join('INNER', $db->quoteName($table2) . ' ON ' . $db->quoteName($joints1) . ' = ' . $db->quoteName($joints2));
		}
		
		$query->where($db->quoteName($conditions[0]) . ' = ' . $db->quote($conditions[1]));
		
		if(isset($order)){
		$query->order($db->quoteName($orders[0]) . $orders[1]);
		}

		$db->setQuery($query);

		// Load the results as a list of stdClass objects (see later for more options on retrieving data).
		$results = $db->loadObjectList();
	}		
		
	public function getMenus($id = 1){
		//check authority
		$valid = $this->getAuth();//authority check
	
		if($valid == 1){
			if (!isset($this->article[$id]))
			{			
		
			// get from xml
			$jinput = JFACTORY::getApplication()->input;

			//get the ordering
			$app = JFactory::getApplication();
		//	$params = $app->getParams();
		//	$order_type = $this->getOrdering();
			$jinput = JFACTORY::getApplication()->input;
			$skey = $jinput->get('skey','','string'); //default page is empty.
			$uscode = $jinput->get('uscode','','string'); //default page is empty.
	
			$db = JFactory::getDbo();
			
			$query = $db->getQuery(true);		
			$query->select(array('a.uscode', 'a.priv', 'a.id','b.link_to_menu','b.menu','b.menu_desc','b.task','b.option_s'));
			$query->from($db->quoteName('#__ccauthlist', 'a')); // change when change table
			$query->join('LEFT', $db->quoteName('#__ccauthmenu', 'b') . ' ON (' . $db->quoteName('a.priv') . ' = ' . $db->quoteName('b.priv') . ')');
			$query->where($db->quoteName('uscode') . ' = '. $db->quote($uscode));
			$query->where($db->quoteName('b.link_to_menu') . ' != ""');
			$query->where($db->quoteName('b.published') . ' = 1'); // only view the menus, not action privileges.

			// Order it by the ordering field.
			$query->order('id ASC');			
			//$query->setLimit($itemsperpage,$skipitems);

			$db->setQuery($query);
			 
			$results = $db->loadObjectList();	

			}
		}
		if($valid == 0){ //authority check
			$results = array(); // if authority is not valid, give no information at all.
		}
		
		return $results;
	}
	
	public function getSomeRows($selects, $table, $key, $where="", $ins="", $ordering="", $by="") {
		// This function is to get eligible items as arrays.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($selects); //array
		$query->from($db->quoteName($table)); // change when change table
		// here is the matching criteria:  
	 	if($where!=""){
			$query->where($db->quoteName($where) . ' = '. $db->quote($ins));
		}
	 	if($ordering!=""){
			$query->order($ordering.$by);
		}
		$db->setQuery($query);
		$result = $db->loadAssocList();
		
		return $result;
	}
	
	
	////////////// GET DETAILS for ID ITEM////////////////
	public function getDetails(){	
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select(array('a.id','a.ref','a.vendor','a.warehouse','a.jnref','a.jndate','a.active','a.price','a.quantity','a.received','a.retur','a.qc','a.itemcode','a.status','d.name as itemname','e.name AS vendorname','c.enname AS tujuan')); //array
		$query->from($db->quoteName('#__ccpurcdetail', 'a')); // change when change table
	//	$query->join('LEFT', $db->quoteName('#__ccpurctrx', 'b') . ' ON ' . $db->quoteName('a.jnref') . ' = ' . $db->quoteName('b.jnref'));
		$query->join('LEFT', $db->quoteName('#__ccwarehousemaster', 'c') . ' ON ' . $db->quoteName('a.warehouse') . ' = ' . $db->quoteName('c.enid'));
		$query->join('LEFT', $db->quoteName('#__ccitemmaster', 'd') . ' ON ' . $db->quoteName('a.itemcode') . ' = ' . $db->quoteName('d.itemcode'));
		$query->join('LEFT', $db->quoteName('#__ccpurvendor', 'e') . ' ON ' . $db->quoteName('a.vendor') . ' = ' . $db->quoteName('e.vendorid'));

		// here is the matching criteria:  
		$query->where($db->quoteName('a.active') . ' = 1');	
		$query->where($db->quoteName('a.ref') . ' = '.$db->quote($this->getPurid()));	
		//$query->where($db->quoteName('a.id') . ' = 268');	

	 	$query->order('a.id DESC');
		
		$db->setQuery($query);
		$results = $db->loadObject(); //single record
		
		//validasi referensi tidak terisi atau nama PO yang tidak ditemukan di database
		if($this->getPurid()=="" || empty($results)){
			$results = "";
		}
		return $results;
	}
	
	////////////// GET LIst of Receivings from invemovs////////////////

	public function getQcs(){

		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select(array('a.id', 'a.ref','a.itemcode', 'a.vendor', 'a.date','a.qc','a.remark','a.usid')); //array
		$query->from($db->quoteName('#__ccpur_rec_qc', 'a')); // change when change table
	//	$query->join('LEFT', $db->quoteName('#__ccpurctrx', 'b') . ' ON ' . $db->quoteName('a.jnref') . ' = ' . $db->quoteName('b.jnref'));
		//$query->join('LEFT', $db->quoteName('#__ccwarehousemaster', 'c') . ' ON ' . $db->quoteName('a.entityfrom') . ' = ' . $db->quoteName('c.enid'));
	//	$query->join('LEFT', $db->quoteName('#__ccitemmaster', 'd') . ' ON ' . $db->quoteName('a.itemcode') . ' = ' . $db->quoteName('d.itemcode'));
	//	$query->join('LEFT', $db->quoteName('#__ccpurvendor', 'e') . ' ON ' . $db->quoteName('a.vendor') . ' = ' . $db->quoteName('e.vendorid'));
	//	$query->join('LEFT', $db->quoteName('#__ccwarehousemaster', 'f') . ' ON ' . $db->quoteName('a.entityto') . ' = ' . $db->quoteName('f.enid'));

		// here is the matching criteria:  
		$query->where($db->quoteName('a.ref') . ' = '.$db->quote($this->getPurid()));	

	 	$query->order('a.id DESC');
		
		$db->setQuery($query);
		return $db->loadObjectList();
		
	}
	////////////// GET LIst of Receivings from invemovs////////////////

	public function getList(){

		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select(array('a.ref','a.entityto', 'a.entityfrom', 'a.duedate', 'a.reqnumber','a.startdate','a.quantity','a.status','a.description','a.usid', 'a.itemcode','a.status','d.name as itemname','c.enname AS enfrom', 'f.enname AS ento')); //array
		$query->from($db->quoteName('#__ccinvemov', 'a')); // change when change table
	//	$query->join('LEFT', $db->quoteName('#__ccpurctrx', 'b') . ' ON ' . $db->quoteName('a.jnref') . ' = ' . $db->quoteName('b.jnref'));
		$query->join('LEFT', $db->quoteName('#__ccwarehousemaster', 'c') . ' ON ' . $db->quoteName('a.entityfrom') . ' = ' . $db->quoteName('c.enid'));
		$query->join('LEFT', $db->quoteName('#__ccitemmaster', 'd') . ' ON ' . $db->quoteName('a.itemcode') . ' = ' . $db->quoteName('d.itemcode'));
	//	$query->join('LEFT', $db->quoteName('#__ccpurvendor', 'e') . ' ON ' . $db->quoteName('a.vendor') . ' = ' . $db->quoteName('e.vendorid'));
		$query->join('LEFT', $db->quoteName('#__ccwarehousemaster', 'f') . ' ON ' . $db->quoteName('a.entityto') . ' = ' . $db->quoteName('f.enid'));

		// here is the matching criteria:  
		$query->where($db->quoteName('a.ref') . ' = '.$db->quote($this->getPurid()));	

	 	$query->order('a.startdate ASC');
		
		$db->setQuery($query);
		$results = $db->loadObjectList();
		
		//validasi referensi tidak terisi atau nama PO yang tidak ditemukan di database
		if($this->getPurid()=="" || empty($results)){
			$results = "";
		}
		return $results;
		
	}
	
	
}