<?php
/*
Sistem Inventory Control dan Sales Tracking - by Chandra
Modification history 15 Agustus 2020
Prod list dan sales list, 
sudah terdapat connection dari new sale ke prodlist, 
dan sebaliknya akan ada update dari perubahan status produksi ke sale list.


Versi 1.03 Inventory
Modifikasi berjalan 15 Agustus utk menambahkan:
- inve_list utk inventory pada ccsalesmaster <-- master inventory.
- invemaintain utk edit rincian salesmaster. 
- tabel ccsalesmaster ditambahkan BOM berupa JSON utk maintain standar penggunaan material.
- static data ini utk benchmark dan usulan perhitungan material utk mengeluarkan material oleh org gudang.

known error for fix:
menu not showing when message is empty. should have different message between having no access and no items to display.
- wipe other data update  than konfirmasi.$salesid) >9
- wipe proddetail screen, model, view.
- Consider renaming ccsalesmaster table, coz it is for inventory / production purpose.
- Consider dashboard and notification systems for every user. Consider simple dual control mechanism.
- Consider e-mail system for out of system notification. Added every user e-mail table and PIC table in the employ. consider renaming employ table for better naming.
if (!filter_var($email, FILTER_VALIDATE_EMAIL)) {
  $emailErr = "Invalid email format";

*/
// No direct access to this file

defined('_JEXEC') or die('Restricted access');

class CCauthController extends JControllerLegacy // cc: change component
{
	public function display($cachable = false, $urlparams = array())
	{
		$cachable = true;
		$task = $this->input->getCmd('view', 'display');
		switch ($task){
			case 'logon':
				$this->input->set('view', 'logon');
				break;
			case 'home':
				$this->input->set('view', 'home');
				break;
			case 'chgpas':
				$this->input->set('view', 'chgpas');
				break;					
			case 'new_sale':
				$this->input->set('view', 'new_sale');
				break;			

			// ***** New Retail Sale **** //
			case 'new_retail_sale':
				$this->input->set('view', 'new_retail_sale');
				break;
				
			case 'new_prod':
				$this->input->set('view', 'new_prod');
				break;
			case 'sale_list':
				$this->input->set('view', 'sale_list');
				break;	
			case 'sale_receipt':
				$this->input->set('view', 'sale_receipt');
				break;
			case 'collectlist':
				$this->input->set('view', 'collectlist');
				break;	
			case 'collectdetail':
				$this->input->set('view', 'collectdetail');
				break;					
			case 'prod_list':
				$this->input->set('view', 'prod_list');
				break;	
			case 'proddetail':
				$this->input->set('view', 'proddetail');
				break;		
			case 'produpdate':
				$this->input->set('view', 'produpdate');
				break;						
			case 'siap_kirim':
				$this->input->set('view', 'siap_kirim');
				break;					
			case 'kirim_fwd':
				$this->input->set('view', 'kirim_fwd');
				break;					
			case 'konfirmasi':
				$this->input->set('view', 'konfirmasi');
				break;

			case 'inve_list':
				$this->input->set('view', 'inve_list');
				break;
			case 'stock_list':
				$this->input->set('view', 'stock_list');
				break;
			case 'invemaintain':
				$this->input->set('view', 'invemaintain');
				break;
			case 'new_inve':
				$this->input->set('view', 'new_inve');
				break;

			default: 
				$this->input->set('view', 'logon');
				break;
		}
		parent::display($cachable = false, $urlparams = false);
	}
	
	public function menu_redirect()
	{
		
		$jinput = JFACTORY::getApplication()->input;
		$redirect =	$this->sanitizeInput($jinput->get('redirect','','string'));
		$skey =	$this->sanitizeInput($jinput->get('skey','','string'));
		$uscode = $this->sanitizeInput($jinput->get('uscode','','string'));
		$id = $this->sanitizeInput($jinput->get('id','','string'));

		
		switch ($redirect){
			case '':
				break;
			case 'chgpas':
				$viewlink = 'chgpas';
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey);		
			break;			
			case 'new_sale':
				$viewlink = 'new_sale';
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey);						
			break;
			case 'new_prod':
				$viewlink = 'new_prod';
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey);						
			break;	
			case 'sale_list':
				$viewlink = 'sale_list';
				$month = $this->sanitizeInput($jinput->get('month','','string')); //get salelist
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey.'&month='.$month);		
				break;	
				
			// ***** New Retail Sale **** //				
			case 'new_retail_sale':
				$viewlink = 'new_retail_sale';
				$id = $this->sanitizeInput($jinput->get('id','','string')); //get enid yang menjual 
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey.'&id='.$id);						
			break;			
			case 'prod_list':
				$viewlink = 'prod_list';
				$month = $this->sanitizeInput($jinput->get('month','','string')); //get salelist
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey.'&month='.$month);		
				break;
				
			case 'proddetail':
				$viewlink = 'produpdate';
				$id = $this->sanitizeInput($jinput->get('id','','string')); //get salelist
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey.'&id='.$id);		
				break;
				
			case 'produpdate':
				$viewlink = 'produpdate';
				$id = $this->sanitizeInput($jinput->get('id','','string')); //get salelist
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey.'&id='.$id);		
				break;
				
			case 'siap_kirim':
				$viewlink = 'siap_kirim';
				$salesid = $this->sanitizeInput($jinput->get('salesid','','string')); //get salesid
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey.'&salesid='.$salesid);		
				break;					

			case 'sale_receipt':
				$viewlink = 'sale_receipt';
				$salesid = $this->sanitizeInput($jinput->get('salesid','','string')); //get salesid
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey.'&salesid='.$salesid);		
				break;
				
			case 'kirim_fwd':
				$viewlink = 'kirim_fwd';
				$salesid = $this->sanitizeInput($jinput->get('salesid','','string')); //get salesid
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey.'&salesid='.$salesid);		
				break;					
			case 'collectlist':
				$viewlink = 'collectlist';
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey);		
				break;				
			case 'collectdetail':
				$viewlink = 'collectdetail';
				$salesid = $this->sanitizeInput($jinput->get('id','','string')); //get salesid
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey.'&id='.$salesid);		
				break;					
			case 'konfirmasi':
				$viewlink = 'konfirmasi';
				$salesid = $this->sanitizeInput($jinput->get('salesid','','string')); //get salesid
				//$salesid = $jinput->get('salesid','','string'); //get salesid
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey.'&salesid='.$salesid);		
				break;

			//************				Versi 1.03 Inventory
			
			case 'inve_list':
				$viewlink = 'inve_list';
	//			$salesid = $this->sanitizeInput($jinput->get('salesid','','string')); 
				//$salesid = $jinput->get('salesid','','string'); //get salesid
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey);		
				break;
			case 'stock_list':
				$viewlink = 'stock_list';
	//			$salesid = $this->sanitizeInput($jinput->get('salesid','','string')); 
				//$salesid = $jinput->get('salesid','','string'); //get salesid
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey.'&id='.$id);		
				break;	
			case 'invemaintain':
				$viewlink = 'invemaintain';
				$id = $this->sanitizeInput($jinput->get('id','','string')); //get salesid
				//$salesid = $jinput->get('salesid','','string'); //get salesid
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey.'&id='.$id);		
				break;
			case 'new_inve':
				$viewlink = 'new_inve';
				$salesid = $this->sanitizeInput($jinput->get('salesid','','string')); //get salesid
				//$salesid = $jinput->get('salesid','','string'); //get salesid
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink.'&uscode='.$uscode.'&skey='.$skey.'&salesid='.$salesid);		
				break;

			
			//************				Versi 1.03 Inventory
			case 'logon':
				$viewlink = 'logon';
				$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view='.$viewlink);		
				break;	
				
			default: 
				break;
		}

		if (isset($viewlink)){
		$mainframe = JFactory::getApplication();
		$mainframe->redirect($link);
		}
		else{
		$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view=logon');	
		$message = "menu not found";
		}
		$mainframe = JFactory::getApplication();
		$mainframe->redirect($link,$message);
	}
	
	
//For action validations
	public function getUsername($skey) {
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName('a.usname')); //change field
		$query->from($db->quoteName('#__ccauthsession', 'a')); // change when change table
		$query->where($db->quoteName('a.passwrd') .' = '.$db->quote($skey));//
		$db->setQuery($query);
		$result = $db->loadResult(); //single data query		//authority check
		return $result;
	}
	
	public function getUserId($skey) {
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName('a.usid')); //change field
		$query->from($db->quoteName('#__ccauthsession', 'a')); // change when change table
		$query->where($db->quoteName('a.passwrd') .' = '.$db->quote($skey));//
		$db->setQuery($query);
		$result = $db->loadResult(); //single data query		//authority check
		return $result;
	}

	public function checkAuth($priv_req) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$skey = $jinput->get('skey','','string'); //default page is empty.
		$uscode = $jinput->get('uscode','','string'); //default page is empty.
			
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName('a.uscode')); //change field
		$query->from($db->quoteName('#__ccauthsession', 'a')); // change when change table
		$query->join('RIGHT', $db->quoteName('#__ccauthlist', 'b') . ' ON (' . $db->quoteName('a.uscode') . ' = ' . $db->quoteName('b.uscode') . ')');
		// here is the matching criteria:  
		$query->where($db->quoteName('a.passwrd') .' = '.$db->quote($skey));// $db->quote($skey));
		$query->where($db->quoteName('b.priv') . ' = '. $db->quote($priv_req));//this is the privilege
		$query->where($db->quoteName('b.uscode') . ' = '. $db->quote($uscode));//this is the privilege
		$db->setQuery($query);
		$results = $db->loadResult(); //single data query
	
		if($results!=""){
			$valid = 1;
			}
			else {
			$valid = 0;
			}
		return $valid;
	}
	
	public function sanitizeInput($data) 
	{
	  $data = trim($data);
	  $data = stripslashes($data);
	  $data = htmlspecialchars($data);
	  return $data;
	}
	
	public function validateCompare($data="", $validData = array())
	{
		//This function to compare a string against valid data in arrays.
		$data = $this->sanitizeInput($data);
		//set default first
		$result = "";// set default result to first valid data if not found
		//compare, if found override result
		foreach ($validData as $testdata){
			if($testdata == $data){				
				$result = $data; //override result
			}
		}
		return $result;
	}

	public function getOneRow($select, $table, $where="", $ins="", $ordering="", $by="") {
		// This function is to get eligible items as arrays.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		if($select==""){
			$query->select('*'); //change field
		} else {
			$query->select($select); //change field
		}
		$query->from($db->quoteName($table)); // change when change table
		// here is the matching criteria:  
	 	if($where!=""){
			$query->where($db->quoteName($where) . ' = '. $db->quote($ins));
		}
	 	if($ordering!=""){
			$query->order($db->quote($ordering.$by));
		}
		$db->setQuery($query);
		$result = $db->loadAssoc();
		
		return $result;
	}
	
	public function getSomeRows($selects, $table, $key, $where="", $ins="", $ordering="", $by="") {
		// This function is to get eligible items as arrays.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($selects); //array
		$query->from($db->quoteName($table)); // change when change table
		// here is the matching criteria:  
	 	if($where!=""){
			$query->where($db->quoteName($where) . ' = '. $db->quote($ins));
		}
	 	if($ordering!=""){
			$query->order($db->quote($ordering.$by));
		}
		$db->setQuery($query);
		$result = $db->loadAssocList($key);
		
		return $result;
	}
	
	
	public function getColumn($select, $table, $where="", $ins="", $ordering="", $by="") {
		// This function is to get eligible items as arrays.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName($select)); //change field
		$query->from($db->quoteName($table)); // change when change table
		// here is the matching criteria:  
	 	if($where!=""){
			$query->where($db->quoteName($where) . ' = '. $db->quote($ins));
		}
	 	if($ordering!=""){
			$query->order($db->quote($ordering.$by));
		}
		$db->setQuery($query);
		$results = $db->loadColumn();
		
		return $results;
	}

	public function getCuid() {
		// This function is to get eligible items as arrays.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName('cuid')); //change field
		$query->from($db->quoteName('#__cccust')); // change when change table
		// here is the matching criteria:  
		$query->where($db->quoteName('status') . ' = '. $db->quote('1'));
		 
		$db->setQuery($query);
		$results = $db->loadColumn();
		
		return $results;
	}
	
	public function getValue($field, $table, $where, $value, $where2="", $value2="", $ordering="", $by="")
	{
		$db = JFactory::getDbo();
		$query = $db
			->getQuery(true)
			->select($field)
			->from($db->quoteName($table));
			if($where !=""){
			$query->where($db->quoteName($where) . " = " . $db->quote($value));
			}
			if($where2 !=""){
			$query->where($db->quoteName($where2) . " = " . $db->quote($value2));
			}
			if($ordering!=""){
			$query->order($db->quoteName($ordering) . $by);
			}
		$db->setQuery($query);
		return $db->loadResult();
	}
	
	public function getValue_for_update($field, $table, $where, $value)
	{
		$db = JFactory::getDbo();
		$query = $db
		->getQuery(true)
		->select($field)
		->from($db->quoteName($table))
		->where($db->quoteName($where) . " = " . $db->quote($value));

		$db->setQuery($query);
		return $db->loadResult();
	}
	
	public function getColumn_not_use($data, $table, $criteria, $value) {
		// This function is to get eligible items as arrays.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName($data));
		$query->from($db->quoteName($table));
		// here is the matching criteria:  
		if(!isset($criteria)){
		$query->where($db->quoteName($criteria) . ' = '. $db->quote($value));
		}
		$db->setQuery($query);
		$results = $db->loadColumn();
		return $results;
	}
	
	function updateThing($field, $data, $table, $criteria1, $value1, $criteria2, $value2){
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);

		// Fields to update.
		$fields = 
		$db->quoteName($field) . ' = ' . $db->quote($data); // field name and data

		// Conditions for which records should be updated.
		$conditions = array(
		$db->quoteName($criteria1) . ' = '. $db->quote($value1), //$criteria1 and value1 matching test
		$db->quoteName($criteria2) . ' = '. $db->quote($value2)); // criteria2 and value 2 matching test

		$query->update($db->quoteName($table))->set($fields)->where($conditions);  // table name 
		$db->setQuery($query);
		$result = $db->execute();
	}

function updateOneRow($table, $object, $primary){
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);

		// Fields to update.
		$many_fields = "";
		if(!empty($object)){			
			//$query->update($db->quoteName($table))->set($many_fields)->where($conditions);  // table name 
			$db->updateObject($table, $object, $primary);
			//$result = $db->execute();
		}
	}
	
	public function getInid($active) {
		// This function is to get eligible items as arrays.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName('itemcode')); //change field
		$query->from($db->quoteName('#__ccsalesmaster')); // change when change table
		// check if only active items are checked
		if($active == "active"){
		$query->where($db->quoteName('status') . ' = '. $db->quote('1'));
		} else{
			// no where
		}
		
		$db->setQuery($query);
		$results = $db->loadColumn();
		return $results;
	}
	
	public function insertRow($fields, $datas, $table){
		
		/* HOW TO USE
		//to define data before insertion
		$fields = array('user_id', 'profile_key', 'profile_value', 'ordering');
		$datas = array();
		$table = '#__ccsalestrail';
		//to use
		$this->insertRows($fields,$datas,$table);
		*/
				
		$db = JFactory::getDbo();

		// Create a new query object.
		$query = $db->getQuery(true);

		// Insert values.
		$values = array();
		
		foreach($datas as $data){
			if (is_int($data)== 1){
				$values[] = $data ;
			}
			else{
				$values[] = $db->quote($data) ;
			}
		}

		// Prepare the insert query.
		$query
			->insert($db->quoteName($table))
			->columns($db->quoteName($fields))
			->values(implode(',', $values));

		// Set the query using our newly populated query object and execute it.
		$db->setQuery($query);
		$db->execute();
		
	}
	
function login()	
		{
		$jinput = JFACTORY::getApplication()->input;
	
		$data = new stdClass();
		$data->usid = $this->sanitizeInput($jinput->get('usid','','string'));
		$data->passwd = $this->sanitizeInput($jinput->get('passwd','','string'));
		
		$routing = $this->sanitizeInput($jinput->get('routing','','string')); //default page is empty.


		//get published option
		$data->published = 1; //set default
		
		//validation process
		$validate = 1;//default success
		$message = "Welcome ".$data->usid.", you are now logged in.". $routing;//default message - cc component change
		
		// check if empty		
		if($data->usid == "" || $data->passwd == "" ){
			$validate = 0;
		}
		
		//check if exceed max length
		if(strlen($data->usid) > 12 || strlen($data->passwd) >25 ){ 
			$validate = 0;
		}
		
		//success, then try login
		if($validate == 1)
		{
			//seek for password match
			function checkPass($usid,$passwd) {
				$db = JFactory::getDbo();
				$query = $db->getQuery(true);
				$query->select(array('usid','usname','uscode','alias')); //change field
				$query->from($db->quoteName('#__ccauth')); // change when change table
				// here is the matching criteria:  
				$query->where($db->quoteName('usid') . ' = '. $db->quote($usid));
				$query->where($db->quoteName('passwrd') . ' = '. $db->quote($passwd));
				 
				$db->setQuery($query);
				$results = $db->loadAssoc(); //single data query
				
				return $results;
				}
				
			$hash = sha1($data->passwd); //patch later for more security
			$random = rand(10,10000);// create random key for session
			$skey = sha1($random.substr($hash, -15,15));   
			$user_row = checkPass($data->usid, $hash);
			$uscode = $user_row['uscode'];
			//validasi password 
			if(!empty($user_row))
			{
			// password is true
			
			//check if authsession for the user is exist
			$check_exist = $this->getValue('usid', '#__ccauthsession', 'usid', $user_row['usid']);
				
			$new_session = new stdClass();
			$new_session->usid = $user_row['usid'];
			$new_session->published = 1;
			$new_session->usname =  $user_row['usname'];
			$new_session->uscode = $user_row['uscode'];
			$new_session->passwrd = $skey;
			$new_session->random = $random;
			$new_session->alias = $user_row['alias'];
			$new_session->status = 1;
				
			if($check_exist !=''){
			//update the authsession if session existed
			$this->updateOneRow('#__ccauthsession', $new_session, 'usid');			
			} else{
			//create new authesession if session not existing
			$execute = JFactory::getDbo()->insertObject('#__ccauthsession', $new_session);
			}
			
			$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view=home&uscode='.$uscode.'&skey='.$skey);
			
			// routing to specific sales ID only.
			if($routing != ""){
					$db = JFactory::getDbo();
					$query = $db->getQuery(true);
					$query->select($db->quoteName('routing')); //change field
					$query->select($db->quoteName('salesid')); //change field
					$query->select($db->quoteName('task')); //change field
					$query->select($db->quoteName('option')); //change field
					$query->from($db->quoteName('#__ccsalesrouting')); // change when change table
					// here is the matching criteria:  
					$query->where($db->quoteName('routing') . ' = '. $db->quote($routing));
					$db->setQuery($query);
					$results = $db->loadObjectList(); //single data query
					
					if(isset($results)){
						$link = \Joomla\CMS\Router\Route::_('index.php?option='.$results[0]->option_s.'&view='.$results[0]->task.'&uscode='.$uscode.'&skey='.$skey.'&salesid='.$results[0]->salesid);
					}
					else {
					}
				}
			//end of routing
			
			} else {
			//password is incorrect
			$link = JRoute::_('index.php?option=com_ccauth&view=logon');
			$message = "Password atau user-ID salah";
			}
		}
		else 
		{
			$link = JRoute::_('index.php?option=com_ccauth&view=logon');
			$message = "Terdapat kesalahan dengan user-ID atau password, coba ulangi kembali";
		}
		//route back
		$mainframe = JFactory::getApplication();
	
		//$link = JRoute::_('index.php?option=com_ccinve&view=messages');
		
		//call email function
		//$sent = $this->_sendEmail();
		
		$mainframe->redirect($link, $message);
	}


function request_move_inve(){
	$checkauth = $this->checkAuth('savesale');//authority to action.
	$jinput = JFACTORY::getApplication()->input;
	$skey = $this->sanitizeInput($jinput->get('skey','','string'));
	$uscode = $this->sanitizeInput($jinput->get('uscode','','string'));
	$inids = $jinput->get('itemcode','','string'); //array
	$enid = $this->sanitizeInput($jinput->get('enid','','string'));
	$request_number = $this->sanitizeInput(str_replace(" ","",$jinput->get('request_number','','string')));

	$request_number = str_replace(" ","",$request_number);

	$duedate = $this->sanitizeInput($jinput->get('duedate','','date'));
	$usid = $this->getUsername($skey);
	$id = $this->sanitizeInput($jinput->get('id','','string'));
	$description = $this->sanitizeInput($jinput->get('description','','string'));
	$types = $this->sanitizeInput($jinput->get('type','','INT'));
	$quans = $jinput->get('quan','','INT'); //array
	$ref = $jinput->get('ref','','string'); //array
	$status = $jinput->get('status','','INT'); //array
	$return_link = $jinput->get('return_link','','string'); //array

	//accomodate goods receiving and retur with certain code $retur="1" and $terima.

	$receiveorreturn = $this->sanitizeInput($jinput->get('receiveorreturn','','string'));
	if($receiveorreturn!=""){
		// INCOMINGS
		if($receiveorreturn=="1")// penerimaan do nothing, only to set the status 9 automatically.
		{
			$status = 3;
			$duedate = date("Y-m-d");
						$duedate = "2022-02-02";
						$types[0] = 1;
		}
		
		if($receiveorreturn=="2") //retur then return items to supplier from warehouse to supplier.		
		{ 
			$destination = $enid;
			$enid = $id;
			$id = $destination;
			$status = 0;
			$duedate = date("Y-m-d");
						$duedate = "2022-02-02";
						$types[0] = 1;
		}
		// OUTGOINGS
		if($receiveorreturn=="3")// penerimaan do nothing, only to set the status 9 automatically.
		{
			$status = 0;
			$duedate = date("Y-m-d");
						$duedate = "2022-02-02";
						$types[0] = 1;
		}
		
		if($receiveorreturn=="4") //retur then return items to supplier from warehouse to supplier.		
		{ 
			$destination = $enid;
			$enid = $id;
			$id = $destination;
			$status = 3;
			$duedate = date("Y-m-d");
						$duedate = "2022-02-02";
						$types[0] = 1;
		}
	}


	if($checkauth == 0){
		$message = 'you are not authorized to do this action';	
		return;
		}
	else {
		//set validity
		$validate = 1;
		$errmessage = "Terjadi Kesalahan. ";
		$globalmessage = "Penyimpanan berhasil. ";
		
		$check_request_number = $this->validateCompare($request_number, $this->getColumn('reqnumber','#__ccinvemov','published',1)); 
		if($check_request_number !="")
		{
			$validate = 0;
			$errmessage .= " Nomor request ".$request_number." sudah ada sebelumnya.";
		}
		if($duedate =="" || $duedate < date("Y-m-d"))
		{
			$validate = 0;
			$errmessage .= " Batas waktu ".$duedate." permintaan tidak valid.";
		}

		$check_enid = $this->validateCompare($enid, $this->getColumn('enid','#__ccwarehousemaster','published',1));
		if($check_enid == "")
		{
			// if no entry at all
			$validate = 0;
			$errmessage .= " Entity code ".$enid." tidak ditemukan pada entry ke ".$i;
		}		
						
		$check_type = $this->validateCompare($types, array(1,2));
		if($check_type == "")
		{
			$validate = 0;
			$errmessage .= " Jenis pengiriman tidak sesuai pada entry ke ".$i;
		}		
				
		for($i=0; $i < count($inids); $i++){
			//check 
			//$check_inid = $this->validateCompare($this->sanitizeInput($inids[$i]), $this->getColumn('itemcode','#__ccinvemaster','published',1));
			$check_inid = $this->validateCompare($this->sanitizeInput($inids[$i]), $this->getColumn('itemcode','#__ccsalesmaster','published',1));
			//check if requested item is existing with sufficient quantity in the entity. - not checked, coz entity might be procurement
			
			if($check_inid == ""){
				// both is missing, so no need to do anything
				$validate = 0;
				$errmessage .= " ID inventory ".$inid." tidak ditemukan pada entry ke ".$i;
			}
			
			if($this->sanitizeInput($quans[$i]) < 1){
				// check quantity variable
				$validate = 0;
				$errmessage .= " Salah satu nilai kurang dari nol pada entry ke ".$i;
			}
			
			if($validate == 1){
				//save item to invemov
				$message .= "Entry ke-".$i." berhasil disimpan";
				// create request on ccinvemov, prepare data
				$data->startdate = date("Y-m-d");//now
				$data->duedate = $duedate; //get from input
				$data->samonth = date("Y-m");// getting month of now
				$data->published = 1; 
				$data->movtype = $types[$i]; //get from input
				$data->reqnumber = $request_number; //get from input
				if($types[$i] == 1){
					$data->entityfrom = $enid;
					$data->entityto = $id;
				} else {
					$data->entityfrom = $id;
					$data->entityto = $enid;
				}
				$data->usid = $usid; //get from user-ID entering request
				$data->itemcode = $inids[$i];
				$data->description = $description; // get from input / status
				$data->quantity = $quans[$i];
				if($status=="" || $status==0){
					$data->status = 0; //starting status is open = 0, unless specified.
				} else{
					$data->status = $status;
				}
				$data->ref = $ref;
				//post the object to table	
				$result = JFactory::getDbo()->insertObject('#__ccinvemov', $data);	
				
				// post to first warehouse
				//check status of entity id, inid, if exist just update the numbers, if not found then create new records
				
				$db = JFactory::getDbo();
				$query = $db->getQuery(true);
				$query->select($db->quoteName(array('id','incoming_req','outgoing_req'))); 
				$query->from($db->quoteName('#__ccwarehouse')); // change when change table
				$query->where($db->quoteName('itemcode') . ' = '. $db->quote($inids[$i]));
				$query->where($db->quoteName('enid') . ' = '. $db->quote($id));
				$db->setQuery($query);
				// Load the results as a list of stdClass objects (see later for more options on retrieving data).
				$check_exist = $db->loadAssoc();
				
				//prepare data in object IN FIRST ENTITY #######################################################################
				$warehouse = new stdClass;
				
				if(!empty($check_exist)){
					// update existing row
					$warehouse->id = $check_exist['id'];
					//get existing number for request incoming or outgoing.
					if($data->movtype == 1){
						$warehouse->incoming_req = $check_exist['incoming_req'] + $quans[$i];
						$message .=$check_exist['incoming_req'];
					} else{
						$warehouse->outgoing_req = $check_exist['outgoing_req'] + $quans[$i];
					}
					
					//override for receiving and return
					if($receiveorreturn=="1")// penerimaan do nothing, only to set the status 9 automatically.
					{
						$warehouse->incoming_req = $check_exist['incoming_req'];// override the above
						$warehouse->incoming_con = $check_exist['incoming_con']+ $quans[$i]; // override the above
					}	
					
					$this->updateOneRow('#__ccwarehouse', $warehouse, 'id');
				} else{
					// insert
					$warehouse->enid = $id;
					$warehouse->enname = $this->getValue('enname', '#__ccwarehousemaster', 'enid', $id); //get enname from the ccwarehousemaster table
					$warehouse->published = 1;
					$warehouse->itemcode = $data->itemcode;
					if($data->movtype == 1){
						$warehouse->incoming_req = $data->quantity;
					} else{
						$warehouse->outgoing_req = $data->quantity;
					}
					//override for receiving and return
					if($receiveorreturn=="1")// penerimaan do nothing, only to set the status 9 automatically.
					{
						$warehouse->incoming_req = 0;
						$warehouse->incoming_con = $data->quantity; // override the above
					}		
					$result = JFactory::getDbo()->insertObject('#__ccwarehouse', $warehouse);
				}
				
				//IF this is from receiving module, then update the purcdetail table 
				if($receiveorreturn=="1")// penerimaan do nothing, only to set the status 9 automatically.
				{
					//get existing receive
					$new_value = $this->getValue('received', '#__ccpurcdetail', 'ref', $ref) + $quans[$i] ;
					$update = new stdClass;
					$update->ref = $ref;
					$update->received = $new_value;
					$this->updateOneRow('#__ccpurcdetail', $update, 'ref');
					
				}
				if($receiveorreturn=="2")// penerimaan do nothing, only to set the status 9 automatically.
				{
					//get existing retur
					$new_value = $this->getValue('retur', '#__ccpurcdetail', 'ref', $ref) + $quans[$i] ;
					$update = new stdClass;
					$update->ref = $ref;
					$update->retur = $new_value;
					$this->updateOneRow('#__ccpurcdetail', $update, 'ref');

				}
				//prepare data in object IN SECOND ENTITY #######################################################################
				
				//check status of entity id, inid, if exist just update the numbers, if not found then create new records
				
				$db = JFactory::getDbo();
				$query = $db->getQuery(true);
				$query->select($db->quoteName(array('id','incoming_req','outgoing_req'))); //change field
				$query->from($db->quoteName('#__ccwarehouse')); // change when change table
				$query->where($db->quoteName('itemcode') . ' = '. $db->quote($inids[$i]));
				$query->where($db->quoteName('enid') . ' = '. $db->quote($enid));
				$db->setQuery($query);
				// Load the results as a list of stdClass objects (see later for more options on retrieving data).
				$check_exist = $db->loadAssoc();
				
				//prepare data in object
				$warehouse = new stdClass;
				
				if(!empty($check_exist)){
					// update existing row
					$warehouse->id = $check_exist['id'];
					//get existing number for request incoming or outgoing.
					if($data->movtype == 1){
						$warehouse->outgoing_req = $check_exist['outgoing_req'] + $quans[$i];
						$message .=$check_exist['outgoing_req'];
					} else{
						$warehouse->incoming_req = $check_exist['incoming_req'] + $quans[$i];
					}
					if($receiveorreturn=="1")// penerimaan do nothing, only to set the status 9 automatically.
					{
						$warehouse->outgoing_req = $check_exist['outgoing_req'];// override the above
						$warehouse->outgoing_con = $check_exist['outgoing_con']+ $quans[$i]; // override the above
					}	
					$this->updateOneRow('#__ccwarehouse', $warehouse, 'id');
				} else{
					// insert
					$warehouse->enid = $enid;
					$warehouse->enname = $this->getValue('enname', '#__ccwarehousemaster', 'enid', $enid); //get enname from the ccwarehousemaster table
					$warehouse->published = 1;
					$warehouse->itemcode = $data->itemcode;
					if($data->movtype == 1){
						$warehouse->outgoing_req = $data->quantity;
					} else{
						$warehouse->incoming_req = $data->quantity;
					}
					//override for receiving and return
				if($receiveorreturn=="1")// penerimaan do nothing, only to set the status 9 automatically.
					{
						$warehouse->outgoing_req = 0; // override the above
						$warehouse->incoming_con = $data->quantity;
					}
					$result = JFactory::getDbo()->insertObject('#__ccwarehouse', $warehouse);
				}
				
				
			} elseif($check_inid == "" && $quans[$i] == 0){
				// do nothing, but dont throw errormessage
				
			} else{
				// do nothing, throw error message
				$message .= $errmessage;
				$globalmessage = "Terdapat kesalahan. ".$message;
			}
		}
	}
	//return message and link
	$link = JRoute::_('index.php?option=com_ccauth&view=stock_list&uscode='.$uscode.'&skey='.$skey.'&id='.$id);
	$mainframe = JFactory::getApplication();

	if($return_link!=""){
		$returns = explode(",",$return_link);
		$link =  JRoute::_('index.php?option='.$returns[0].'&view='.$returns[1].'&uscode='.$uscode.'&skey='.$skey.'&'.$returns[2].'='.$returns[3]);
	}

	$mainframe->redirect($link, $message);
}

function saveitem($ref, $customer, $warehouse, $itemcode, $salesid, $quan, $nominal, $remark, $collect_ref, $date, $table, $status="", $sent=0) //useful function for saving new sales.
{
	if($itemcode == "" && $quan == 0 && $nominal == 0) {
	//dont do anything if empty
	}
	else{
		// Get a db connection.
		$db = JFactory::getDbo();

		// Create a new query object.
		$query = $db->getQuery(true);

		// Insert columns.
		$columns = array('ref','customer','warehouse','published', 'salesid', 'itemcode', 'quantity', 'price', 'sent', 'remark', 'collect_ref', 'status','active', 'date');

		//check status, jika selesai (retail, langsung diisi nilai 9
		if($status=="retail"){
			// Insert Retail.
			$values = array($db->quote($ref), $db->quote($customer), $db->quote($warehouse),1, $db->quote($salesid), $db->quote($itemcode), $db->quote($quan), $db->quote($nominal), $db->quote($sent), $db->quote($remark),$db->quote($collect_ref), 9,1, $db->quote($date) );

		} else {
			// Insert Usual Sales.
			$values = array($db->quote($ref), $db->quote($customer), $db->quote($warehouse),1, $db->quote($salesid), $db->quote($itemcode), $db->quote($quan), $db->quote($nominal), $db->quote($sent), $db->quote($remark),$db->quote($collect_ref), 0,1, $db->quote($date) );
		}

		// Prepare the insert query.
		$query
			->insert($db->quoteName('#__ccsalesdetail'))
			->columns($db->quoteName($columns))
			->values(implode(',', $values));

		// Set the query using our newly populated query object and execute it.
		$db->setQuery($query);
		$db->execute();
		$new_row_id = $db->insertid();
		return $new_row_id;
	}
}

function save_new_prod($itemcode, $quan, $nominal, $object, $table){
	if($itemcode == "" && $quan == 0 && $nominal == 0) {
	//dont do anything if empty
	}
	else{
	$result = JFactory::getDbo()->insertObject($table, $object);	
	}
}

	
// function sales new
function validateDate($date, $format = 'Y-m-d H:i:s') //return 1 for true, nothing for false
	{
	$d = DateTime::createFromFormat($format, $date);
	return $d && $d->format($format) == $date;
	}

function savesale()	// main function to save a new sales ID
	{
	$checkauth = $this->checkAuth('savesale');//authority to action.
	$jinput = JFACTORY::getApplication()->input;
	$skey = $this->sanitizeInput($jinput->get('skey','','string'));
	$uscode = $this->sanitizeInput($jinput->get('uscode','','string'));
	
	if($checkauth == 0){
		$message = 'you are not authorized to do this action';	
		return;
		}
	else {
		//validations
		$validate = 1;//default success
		$message = JText::_('COM_CCJOURNAL_SUCCESSFUL_POST');//default message - cc component change
		$errmessage = "Terjadi Kesalahan: ";
	
		//************* UNBALANCED DEBET / CREDIT VALIDATION *************//

		$nom1 = str_replace(",","",$jinput->get('nominal1'));
		$nom2 = str_replace(",","",$jinput->get('nominal2'));
		$nom3 = str_replace(",","",$jinput->get('nominal3'));		
		$nom4 = str_replace(",","",$jinput->get('nominal4'));
		$nom5 = str_replace(",","",$jinput->get('nominal5'));

		//add more
		
		$quan1 = str_replace(",","",$jinput->get('quan1'));
		$quan2 = str_replace(",","",$jinput->get('quan2'));
		$quan3 = str_replace(",","",$jinput->get('quan3'));
		$quan4 = str_replace(",","",$jinput->get('quan4'));
		$quan5 = str_replace(",","",$jinput->get('quan5'));
		
		//add more	

		$nominal1 = $this->sanitizeInput($nom1);
		$nominal2 = $this->sanitizeInput($nom2);
		$nominal3 = $this->sanitizeInput($nom3);
		$nominal4 = $this->sanitizeInput($nom4);
		$nominal5 = $this->sanitizeInput($nom5);

		//add more
		
		$saleid1 = $this->sanitizeInput($jinput->get('saleid1','','INT'));
		$saleid2 = $this->sanitizeInput($jinput->get('saleid2','','INT'));
		$saleid3 = $this->sanitizeInput($jinput->get('saleid3','','INT'));
		$saleid4 = $this->sanitizeInput($jinput->get('saleid4','','INT'));
		$saleid5 = $this->sanitizeInput($jinput->get('saleid5','','INT'));

		//add more
		
		$quan1 = $this->sanitizeInput($quan1);
		$quan2 = $this->sanitizeInput($quan2);
		$quan3 = $this->sanitizeInput($quan3);		
		$quan4 = $this->sanitizeInput($quan4);
		$quan5 = $this->sanitizeInput($quan5);

		//add more
		$remark1 = $this->sanitizeInput($jinput->get('remark1','','string'));
		$remark2 = $this->sanitizeInput($jinput->get('remark2','','string'));
		$remark3 = $this->sanitizeInput($jinput->get('remark3','','string'));
		$remark4 = $this->sanitizeInput($jinput->get('remark4','','string'));
		$remark5 = $this->sanitizeInput($jinput->get('remark5','','string'));

		//add more

		$savalue = ($quan1*$nom1)+($quan2*$nom2)+($quan3*$nom3)
		+($quan4*$nom4)+($quan5*$nom5)
		// add more
		; 
		
		//************* INCOMPLETE FIELD VALIDATION *************//
		
		$sadate = $this->sanitizeInput($jinput->get('purdate','','date'));
		$duedate = $this->sanitizeInput($jinput->get('duedate','','date'));
		$skey = $this->sanitizeInput($jinput->get('skey','','string'));
		$connect_sales = $this->sanitizeInput($jinput->get('connect_sales',0,'INT'));

		$d = date_parse_from_format("Y-m-d", $sadate);
		$month = ($d["year"] *100) + $d["month"];

		$description = $this->sanitizeInput($jinput->get('description','','string'));
		$ponumber = $this->sanitizeInput($jinput->get('ponumber','','string'));
		$salesid = $this->sanitizeInput($jinput->get('salesid','','string'));
		//trim Sales ID should have no space
		$salesid = str_replace(" ","",$salesid);
		
		$customer = $this->sanitizeInput($jinput->get('cuid','','string'));
		$customer = explode("-", $customer);
		
		$warehouse = $this->sanitizeInput($jinput->get('warehouse','','string'));
		$warehouse = explode("-", $warehouse);

		// **** continue to add as necessary
		$inid1 = $this->sanitizeInput($jinput->get('inid1'));
		$inid1 = explode("-", $inid1);
		
		$inid2 = $this->sanitizeInput($jinput->get('inid2'));
		$inid2 = explode("-", $inid2);
		
		$inid3 = $this->sanitizeInput($jinput->get('inid3'));
		$inid3 = explode("-", $inid3);

		$inid4 = $this->sanitizeInput($jinput->get('inid4'));
		$inid4 = explode("-", $inid4);		
		
		$inid5 = $this->sanitizeInput($jinput->get('inid5'));
		$inid5 = explode("-", $inid5);
		//add more
		

//		$itemcode1 = $this->validateCompare($inid1[0], $this->getInid('active'));
		$itemcode1 = $this->validateCompare($inid1[0], $this->getColumn('itemcode','#__ccsalesmaster','status',1));
		$itemcode2 = $this->validateCompare($inid2[0], $this->getInid('active'));
		$itemcode3 = $this->validateCompare($inid3[0], $this->getInid('active'));
		$itemcode4 = $this->validateCompare($inid4[0], $this->getInid('active'));
		$itemcode5 = $this->validateCompare($inid5[0], $this->getInid('active'));
		//add more
		
//		$customer = $this->validateCompare($customer[0], $this->getCuid());
		$customer = $this->validateCompare($customer[0], $this->getColumn('cuid','#__cccust','status',1));
					
		$warehouse = $this->validateCompare($warehouse[0], $this->getColumn('enid','#__ccwarehousemaster','status',1));
					
		$check_connect_sales = $this->validateCompare($connect_sales, array(0,1));

		$date_check1 = $this->validateDate($sadate, 'Y-m-d');
		$date_check2 = $this->validateDate($duedate, 'Y-m-d');
		
		//************* DUPLICATE SALES ID VALIDATION *************//
		
		$check_salesid = $this->validateCompare($salesid, $this->getColumn('salesid','#__ccsales','active',1));
		if($check_salesid !=""){
			$validate = 0;
			$errmessage .=" Sales ID sudah ada.";
		}
		
		//function to check incomplete
		$field_pass = 0; //as no errors found
		
		function fieldpass($glid,$quan,$nominal){
			$field_pass = 0; //default value if no match
			if($glid == "" || $quan < 1 || $nominal < 1) {
			$field_pass = 3;
			}
			if($glid != "" && $quan < 1 ) {
			$field_pass = 4;
			}
			if($glid != "" && $nominal < 1 ) {
			$field_pass = 4;
			}
			if($glid == "" && $quan == 0 && $nominal == 0 ) {
			$field_pass = 0;
			}
			if(strlen($glid) > 35 || strlen($quan) > 12 ||  strlen($nominal) > 12) {
			$field_pass = 2;
			}
			return $field_pass;
		}
		
		$field_pass = $field_pass + fieldpass($itemcode1,$quan1,$nominal1); 
		$field_pass = $field_pass + fieldpass($itemcode2,$quan2,$nominal2);
		$field_pass = $field_pass + fieldpass($itemcode3,$quan3,$nominal3);
		$field_pass = $field_pass + fieldpass($itemcode4,$quan4,$nominal4);
		$field_pass = $field_pass + fieldpass($itemcode5,$quan5,$nominal5);
		// **** continue to add as necessary
				
		
		//*************FINAL VALIDATION***************//		
		if($date_check1 == 0 || $date_check2 == 0 || $salesid == "" || $customer == "" || $warehouse == "" || $field_pass > 0 || $check_connect_sales ==""){
			$validate = 0;
			$errmessage .= "Tanggal, customer, atau nomor sales ID tidak boleh kosong, atau tidak ada atau tidak aktif ";
			$errmessage .= '<br/>'.
			'date: '.$sadate .
			'SalesID: '.$salesid .
			'field: '.$field_pass .
			'connect: '.$connect_sales.
			'warehouse: '.$warehouse.
			'customer: '.$customer; 
		}
		
		//check if exceed max length
		if(strlen($description) > 99 || strlen($salesid) > 25 ){ 
			$validate = 0;
			$errmessage .= "jumlah informasi deskripsi atau informasi lainnya terlalu panjang.";
		}
		
		//success, then post result
		if($validate == 1){
			//create new unique id for details
			$ref1 = $salesid."001";
			$ref2 = $salesid."002";
			$ref3 = $salesid."003";
			$ref4 = $salesid."004";
			$ref5 = $salesid."005";
						
			//save sales detail
			$saleid1 = $this->saveitem($ref1, $customer, $warehouse, $itemcode1,  $salesid, $quan1, $nominal1, $remark1, $ref1, $sadate, '#__ccsalesdetail');
			$this->saveitem($ref2, $customer, $warehouse, $itemcode2, $salesid,  $quan2, $nominal2, $remark2, $ref2, $sadate, '#__ccsalesdetail');
			$this->saveitem($ref3, $customer, $warehouse, $itemcode3, $salesid, $quan3, $nominal3, $remark3, $ref3, $sadate, '#__ccsalesdetail');
			$this->saveitem($ref4, $customer, $warehouse, $itemcode4, $salesid, $quan4, $nominal4, $remark4, $ref4, $sadate, '#__ccsalesdetail');
			$this->saveitem($ref5, $customer, $warehouse, $itemcode5, $salesid, $quan5, $nominal5, $remark5, $ref5, $sadate, '#__ccsalesdetail');
			//add more
				
			//prepare post to production	
			$values = new stdClass();
			
			$values->ponumber = $ponumber;
			$values->salesid = $salesid;
			$values->saleid = $saleid1;
			$values->itemcode = $itemcode1;
			$values->startdate = $sadate;
			$values->duedate = $duedate;
			$values->month = $month;
			$values->approver = $this->getValue('alias','#__ccauthsession', 'passwrd', $skey, 'id', ' ASC');
			$values->pic = 'PO';
			$values->target = $quan1;
			$values->published = 1;
			$values->status = 0;
			if($connect_sales == 1){
			$values->connect = 1;
			} else{
			$values->connect = 0;	
			}
			//post to productlist
			$this->save_new_prod($itemcode1, $quan1, $nominal1, $values,'#__ccprodlist');
			
			//$values->saleid = $saleid2;
			$values->saleid = $saleid1+1; //try
			$values->itemcode = $itemcode2;
			$values->target = $quan2;
			
			$this->save_new_prod($itemcode2, $quan2, $nominal2, $values,'#__ccprodlist');
			
		//	$values->saleid = $saleid3;
			
			$values->saleid = $saleid1+2; //try
			$values->itemcode = $itemcode3;
			$values->target = $quan3;
			
			$this->save_new_prod($itemcode3, $quan3, $nominal3, $values,'#__ccprodlist');
			
			
	//		$values->saleid = $saleid4;
			
			$values->saleid = $saleid1+3; //try
			$values->itemcode = $itemcode4;
			$values->target = $quan4;
			
			$this->save_new_prod($itemcode4, $quan4, $nominal4, $values,'#__ccprodlist');
			
//			$values->saleid = $saleid5;
			
			$values->saleid = $saleid1+4; //try
			$values->itemcode = $itemcode5;
			$values->target = $quan5;
			
			$this->save_new_prod($itemcode5, $quan5, $nominal5, $values,'#__ccprodlist');
			
			/*
			//$lastID = $this->getValue('id', '#__ccsalesdetail', 'status',1,'id', 'DESC');
			$prod = new stdClass();
			$prod->salesid = $data->salesid;
			$prod->ponumber = $ponumber;
			
			$prod->published = 1 ;
			$prod->itemcode = $data->itemcode ;
			$prod->approver = "PO"; //default value 
			$prod->target = $data->quantity;
			$prod->startdate = $sadate;
			$prod->duedate = $duedate;
			$prod->pic = "PO";
			//post
			$post = JFactory::getDbo()->insertObject('#__ccprodlist',$prod);	
			*/
			
			//*************POST TO SALES TRANSACTIONS ***************//	
			$salesjournal = new stdClass();
			$salesjournal->salesid = $salesid;
			$salesjournal->sadate = $sadate; 
			$salesjournal->duedate = $duedate; 
			$salesjournal->samonth = $month; 
			$salesjournal->published = 1; 
			$salesjournal->active = 1; 
			$salesjournal->cuid = $customer;
			$salesjournal->ponumber = $ponumber;
			$salesjournal->description = $description;
			$salesjournal->value = $savalue;
			$salesjournal->status = 0;
			$salesjournal->usid = $this->getUsername($skey);
			$result = JFactory::getDbo()->insertObject('#__ccsales',$salesjournal); 

			//post audit trail		
			$username = $this->getUsername($skey);
			$fields = array('published', 'status', 'remark');
			
			$datas = array(1,1,'New|Sale|'.$salesid.'|'.$sadate.'|'.$customer.'|'.$savalue.'|'.$username);
			$table = '#__ccsalestrail';
			//to post
			$this->insertRow($fields,$datas,$table);
			
			//post routing		
			//$username = $this->getUsername($skey);
			$fields = array('routing', 'salesid', 'task', 'option');
			$datas = array($salesid, $salesid, 'konfirmasi', 'com_ccauth');
			$table = '#__ccsalesrouting';
			//to post
			$this->insertRow($fields,$datas,$table);
			
			$message = 'Sales baru telah disimpan';
		}
		else { 
		// theres error, do nothing.
		$message = $errmessage;
		}
		//route back

		}
		$link = JRoute::_('index.php?option=com_ccauth&view=sale_list&uscode='.$uscode.'&skey='.$skey);
		$mainframe = JFactory::getApplication();
		$mainframe->redirect($link, $message);
	}	

	function saveretail()	// main function to save a new retail sales ID
	{
	//Check authority utk melakukan function ini
	$checkauth = $this->checkAuth('authall'); // sementara
	
	//Ambil semua input dari form
	$jinput = JFACTORY::getApplication()->input;
	
	$skey = $this->sanitizeInput($jinput->get('skey','','string'));
	$uscode = $this->sanitizeInput($jinput->get('uscode','','string'));
	
	if($checkauth == 0){
		$message = 'you are not authorized to do this action';	
		return;
		}
	else {
		//validations
		$validate = 1;//default success
		$message = "Pembuatan Penjualan Retail berhasil";
		$errmessage = "Terjadi Kesalahan: ";
	
		//************* UNBALANCED DEBET / CREDIT VALIDATION *************//

		$nom1 = str_replace(",","",$jinput->get('nominal1'));
		$nom2 = str_replace(",","",$jinput->get('nominal2'));
		$nom3 = str_replace(",","",$jinput->get('nominal3'));		
		$nom4 = str_replace(",","",$jinput->get('nominal4'));
		$nom5 = str_replace(",","",$jinput->get('nominal5'));

		//add more
		
		$quan1 = str_replace(",","",$jinput->get('quan1'));
		$quan2 = str_replace(",","",$jinput->get('quan2'));
		$quan3 = str_replace(",","",$jinput->get('quan3'));
		$quan4 = str_replace(",","",$jinput->get('quan4'));
		$quan5 = str_replace(",","",$jinput->get('quan5'));
		
		//add more	

		$nominal1 = $this->sanitizeInput($nom1);
		$nominal2 = $this->sanitizeInput($nom2);
		$nominal3 = $this->sanitizeInput($nom3);
		$nominal4 = $this->sanitizeInput($nom4);
		$nominal5 = $this->sanitizeInput($nom5);

		//add more
		
		$quan1 = $this->sanitizeInput($quan1);
		$quan2 = $this->sanitizeInput($quan2);
		$quan3 = $this->sanitizeInput($quan3);		
		$quan4 = $this->sanitizeInput($quan4);
		$quan5 = $this->sanitizeInput($quan5);

		//add more

		$savalue = ($quan1*$nom1)+($quan2*$nom2)+($quan3*$nom3)+($quan4*$nom4)+($quan5*$nom5);
		
		
		//************* INCOMPLETE FIELD VALIDATION *************//
		
		$sadate = $this->sanitizeInput($jinput->get('sadate','','date'));

		$d = date_parse_from_format("Y-m-d", $sadate);
		$month = ($d["year"] *100) + $d["month"];

		$description = $this->sanitizeInput($jinput->get('description','','string'));
		$ponumber = $this->sanitizeInput($jinput->get('ponumber','','string'));
		$salesid = $this->sanitizeInput($jinput->get('salesid','','string'));
		//trim Sales ID should have no space
		$salesid = str_replace(" ","",$salesid);		
		
		// **** save retail only **** //
		$customer = "CUST999"; // Khusus Retail
		$warehouse = "CUST999";// Khusus Retail
		$entityfrom = $this->sanitizeInput($jinput->get('entityfrom','','string'));
		$usid = $this->sanitizeInput($jinput->get('usid','','string'));

		$type = $this->sanitizeInput($jinput->get('type'));
		
		// **** continue to add as necessary
		$inid1 = $this->sanitizeInput($jinput->get('inid1'));
		$inid1 = explode("-", $inid1);
		
		$inid2 = $this->sanitizeInput($jinput->get('inid2'));
		$inid2 = explode("-", $inid2);
		
		$inid3 = $this->sanitizeInput($jinput->get('inid3'));
		$inid3 = explode("-", $inid3);

		$inid4 = $this->sanitizeInput($jinput->get('inid4'));
		$inid4 = explode("-", $inid4);		
		
		$inid5 = $this->sanitizeInput($jinput->get('inid5'));
		$inid5 = explode("-", $inid5);		

//		$itemcode1 = $this->validateCompare($inid1[0], $this->getInid('active'));
		$itemcode1 = $this->validateCompare($inid1[0], $this->getColumn('itemcode','#__ccsalesmaster','status',1));
		$itemcode2 = $this->validateCompare($inid2[0], $this->getInid('active'));
		$itemcode3 = $this->validateCompare($inid3[0], $this->getInid('active'));
		$itemcode4 = $this->validateCompare($inid4[0], $this->getInid('active'));
		$itemcode5 = $this->validateCompare($inid5[0], $this->getInid('active'));
		//add more
		
//		$customer = $this->validateCompare($customer[0], $this->getCuid());
		$customer = $this->validateCompare($customer, $this->getColumn('cuid','#__cccust','status',1));
		$warehouse = $this->validateCompare($warehouse, $this->getColumn('enid','#__ccwarehousemaster','status',1));		
		$date_check1 = $this->validateDate($sadate, 'Y-m-d');
		
		//************* DUPLICATE SALES ID VALIDATION *************//
		
		$check_salesid = $this->validateCompare($salesid, $this->getColumn('salesid','#__ccsales','active',1));
		
		// VALIDASI KECUKUPAN BARANG PADA GUDANG
		// Validasi itemcode pada gudang tersebut
		$check_item_warehouse1 = $this->getValue('available', '#__ccwarehouse', 'enid', $entityfrom, 'itemcode', $itemcode1);
		$check_item_warehouse2 = $this->getValue('available', '#__ccwarehouse', 'enid', $entityfrom, 'itemcode', $itemcode2);
		$check_item_warehouse3 = $this->getValue('available', '#__ccwarehouse', 'enid', $entityfrom, 'itemcode', $itemcode3);
		$check_item_warehouse4 = $this->getValue('available', '#__ccwarehouse', 'enid', $entityfrom, 'itemcode', $itemcode4);
		$check_item_warehouse5 = $this->getValue('available', '#__ccwarehouse', 'enid', $entityfrom, 'itemcode', $itemcode5);

		// Validasi jumlah sisa (available) itemcode tersebut
		$check_available1 = $check_item_warehouse1 - $quan1;
		$check_available2 = $check_item_warehouse2 - $quan2;
		$check_available3 = $check_item_warehouse3 - $quan3;
		$check_available4 = $check_item_warehouse4 - $quan4;
		$check_available5 = $check_item_warehouse5 - $quan5;		
		
		if($check_available1 < 0 || $check_available2 < 0 || $check_available3 < 0 || $check_available4 < 0 || $check_available5 < 0) {
		//jika minus
			$validate = 0;
			$errmessage .=" salah satu item kurang dari yang hendak dijual. ";
		}		
		
		if($check_item_warehouse1 == "" && $check_item_warehouse2 ==  "" && $check_item_warehouse3 == ""  && $check_item_warehouse4 == "" && $check_item_warehouse5 == "") {
			$validate = 0;
			$errmessage .=" Tidak ada itemcode yang sesuai dengan stok gudang. ";
		}
		if($check_salesid !=""){
			$validate = 0;
			$errmessage .=" Sales ID sudah ada.";
		}
		
		//function to check incomplete
		$field_pass = 0; //as no errors found
		
		function fieldpass($glid,$quan,$nominal){
			$field_pass = 0; //default value if no match
		
			if($glid == "") {
				$field_pass = 3;				
				//Give error message			
				$errmessage .=" Inventory ID ".$glid." tidak valid";
			}
			if($quan < 1 ) {
				$field_pass = 4;
				//Give error message			
				$errmessage .=" Quantity tidak boleh nol atau kurang ".$quan." pada ".$glid;
			}			
			
			if($nominal < 1 ) {
				$field_pass = 4;
				//Give error message			
				$errmessage .=" Harga tidak boleh nol atau minus ".$nominal." pada ".$glid;
			}
			
			if($glid == "" && $quan == 0 && $nominal == 0 ) {
				$field_pass = 0;
			}
			if(strlen($glid) > 35 || strlen($quan) > 12 ||  strlen($nominal) > 12) {
				$field_pass = 2;
				//Give error message			
				$errmessage .=" Itemcode, atau kuantitas atau harga melebihi panjang normal pada ".$glid;
			}
			
			return $field_pass;
		}
		
		$field_pass = $field_pass + fieldpass($itemcode1,$quan1,$nominal1);
		$field_pass = $field_pass + fieldpass($itemcode2,$quan2,$nominal2);
		$field_pass = $field_pass + fieldpass($itemcode3,$quan3,$nominal3);
		$field_pass = $field_pass + fieldpass($itemcode4,$quan4,$nominal4);
		$field_pass = $field_pass + fieldpass($itemcode5,$quan5,$nominal5);
		// **** continue to add as necessary
				
		
		//*************FINAL VALIDATION***************//		
		if($date_check1 == 0 || $salesid == "" || $customer == "" || $warehouse == "" || $field_pass != 0 ){
			$validate = 0;
			$errmessage .= "Tanggal, customer, atau nomor sales ID tidak boleh kosong, atau tidak ada atau tidak aktif ";
			$errmessage .= '<br/>'.
			'date: '.$sadate .
			'SalesID: '.$salesid .
			'field: '.$field_pass .
			'warehouse: '.$warehouse.
			'customer: '.$customer; 
		}
		
		//check if exceed max length
		if(strlen($description) > 99 || strlen($salesid) > 25 ){ 
			$validate = 0;
			$errmessage .= "jumlah informasi deskripsi atau informasi lainnya terlalu panjang.";
		}
		
		//success, then post result
		if($validate == 1){
			//create new unique id for details
			$ref1 = $salesid."001";
			$ref2 = $salesid."002";
			$ref3 = $salesid."003";
			$ref4 = $salesid."004";
			$ref5 = $salesid."005";
			$collect_ref = "PAY".$salesid;
			//save sales detail
			$saleid1 = $this->saveitem($ref1, $customer, $warehouse, $itemcode1, $salesid, $quan1, $nominal1, $remark, $collect_ref, $sadate, '#__ccsalesdetail', 'retail' , $quan1) ;
			$this->saveitem($ref2, $customer, $warehouse, $itemcode2, $salesid, $quan2, $nominal2, $remark, $collect_ref, $sadate, '#__ccsalesdetail' , 'retail' , $quan2);
			$this->saveitem($ref3, $customer, $warehouse, $itemcode3, $salesid, $quan3, $nominal3, $remark, $collect_ref, $sadate, '#__ccsalesdetail', 'retail', $quan3);
			$this->saveitem($ref4, $customer, $warehouse, $itemcode4, $salesid, $quan4, $nominal4, $remark, $collect_ref, $sadate, '#__ccsalesdetail', 'retail' , $quan4);
			$this->saveitem($ref5, $customer, $warehouse, $itemcode5, $salesid, $quan5, $nominal5, $remark, $collect_ref, $sadate, '#__ccsalesdetail', 'retail', $quan5);
			//add more
				
			//*************POST TO SALES TRANSACTIONS ***************//	
			$salesjournal = new stdClass();
			$salesjournal->salesid = $salesid;
			$salesjournal->sadate = $sadate; 
			$salesjournal->duedate = $sadate; 
			$salesjournal->samonth = $month; 
			$salesjournal->published = 1; 
			$salesjournal->active = 1; 
			$salesjournal->cuid = $customer;
			$salesjournal->ponumber = $ponumber;
			$salesjournal->description = $description;
			$salesjournal->value = $savalue;
			$salesjournal->status = 9; // Khusus Retail langsung selesai
			$salesjournal->usid = $this->getUsername($skey);
			$result = JFactory::getDbo()->insertObject('#__ccsales',$salesjournal); 

			
			//post routing		
			//$username = $this->getUsername($skey);
			$fields = array('routing', 'salesid', 'task', 'option');
			$datas = array($salesid, $salesid, 'konfirmasi', 'com_ccauth');
			$table = '#__ccsalesrouting';
			//to post
			$this->insertRow($fields,$datas,$table);

			
			function saveinvemov($sadate, $month, $published, $movtype, $ponumber, $ref, $entityfrom, $warehouse, $usid, $itemcode, $description, $quan, $status) //useful function for saving new sales.
			{
			if($itemcode == "" && $quan == 0) {
			//dont do anything if empty
			}
			else{
				// Get a db connection.
				$db = JFactory::getDbo();

				// Create a new query object.
				$query = $db->getQuery(true);

				// Insert columns.
				$columns = array('startdate', 'duedate', 'samonth', 'published', 'movtype', 'reqnumber', 'ref', 'entityfrom', 'entityto', 'usid', 'itemcode', 'description', 'quantity', 'status');

				// Insert values.
				$values = array($db->quote($sadate), $db->quote($sadate), $db->quote($month), 1, 1, $db->quote($ponumber), $db->quote($ref), $db->quote($entityfrom), $db->quote($warehouse), $db->quote($usid), $db->quote($itemcode), $db->quote($description), $db->quote($quan), 9 );


				// Prepare the insert query.
				$query
					->insert($db->quoteName('#__ccinvemov'))
					->columns($db->quoteName($columns))
					->values(implode(',', $values));

				// Set the query using our newly populated query object and execute it.
				$db->setQuery($query);
				$db->execute();
				$new_row_id = $db->insertid();
				return $new_row_id;
				}
			}
						
			//*************POST TO INVEMOV ***************//
			saveinvemov($sadate, $month,1,1, $ponumber, $ref1, $entityfrom, $warehouse, $usid, $itemcode1, $description, $quan1, 9);
			saveinvemov($sadate, $month,1,1, $ponumber, $ref2, $entityfrom, $warehouse, $usid, $itemcode2, $description, $quan2, 9);
			saveinvemov($sadate, $month,1,1, $ponumber, $ref3, $entityfrom, $warehouse, $usid, $itemcode3, $description, $quan3, 9);
			saveinvemov($sadate, $month,1,1, $ponumber, $ref4, $entityfrom, $warehouse, $usid, $itemcode4, $description, $quan4, 9);
			saveinvemov($sadate, $month,1,1, $ponumber, $ref5, $entityfrom, $warehouse, $usid, $itemcode5, $description, $quan5, 9);		
			
			
			//*************POST TO WAREHOUSE ***************//	
			
			//Function to save setiap item
			$this->savewarehouse($check_item_warehouse1, $quan1, $entityfrom, $itemcode1);
			$this->savewarehouse($check_item_warehouse2, $quan2, $entityfrom, $itemcode2);
			$this->savewarehouse($check_item_warehouse3, $quan3, $entityfrom, $itemcode3);
			$this->savewarehouse($check_item_warehouse4, $quan4, $entityfrom, $itemcode4);
			$this->savewarehouse($check_item_warehouse5, $quan5, $entityfrom, $itemcode5);

				
			function saveremark($itemcode,$nominal,$quan){
				if($itemcode == "" || $nominal == 0|| $quan == 0 ){
				} else {
				$remark = " Item ".$itemcode." ".$quan." bh @ ".$nominal. ". ";
				}
				return $remark;
			}
			$remark .= "Penagihan atas penjualan ".$salesid;
			$remark .= 	saveremark($itemcode1, $nominal1, $quan1);
			$remark .= 	saveremark($itemcode2, $nominal2, $quan2);
			$remark .= 	saveremark($itemcode3, $nominal3, $quan3);
			$remark .= 	saveremark($itemcode4, $nominal4, $quan4);
			$remark .= 	saveremark($itemcode5, $nominal5, $quan5);
				
			//*************POST TO SALE_COLLECT ***************//	
			$sale_collect = new stdClass();
			$sale_collect->customer = $customer;
			$sale_collect->collect_ref = "PAY".$salesid;
			$sale_collect->ref = $ref; 
			$sale_collect->collect_date = $sadate; 
			$sale_collect->payment = $savalue;
			$sale_collect->eligible = $savalue;
			$sale_collect->remark = $remark; 			
			$sale_collect->active = 1; 
			$sale_collect->status = 9;
			$result = JFactory::getDbo()->insertObject('#__ccsale_collect',$sale_collect);

				
			//*************POST TO SALE_COLLECT_DETAILS ***************//	
			$collect_detail = new stdClass();
			$collect_detail->customer = $customer;
			$collect_detail->collect_date = $sadate; 
			$collect_detail->collect_ref = "PAY".$salesid;
			$collect_detail->payment = $savalue; 
			$collect_detail->payment_type = $type; 
			$collect_detail->remark = $description; 
			$collect_detail->active = 1;
			$result = JFactory::getDbo()->insertObject('#__ccsale_collect_details',$collect_detail);
 			
			$message = 'Sales baru telah disimpan';
		}
		
		else { 
		// theres error, do nothing.
		$message = $errmessage;
		}
		//route back

		}
		$link = JRoute::_('index.php?option=com_ccauth&view=sale_receipt&uscode='.$uscode.'&skey='.$skey.'&salesid='.$salesid);
		$mainframe = JFactory::getApplication();
		$mainframe->redirect($link, $message);
	}		

function savewarehouse($check_item_warehouse, $quan, $entityfrom, $itemcode){
//validasi apakah itemcode tersebut terisi dan ada di database
	if($check_item_warehouse == 0 || $check_item_warehouse == ""){ 
	//nothing to do, tidak disave.
	} else{
	$new_quantity = $check_item_warehouse - $quan;
	//update to field available dengan kriteria enid dan itemcode
	$this->updateThing('available', $new_quantity, '#__ccwarehouse', 'enid', $entityfrom, 'itemcode', $itemcode);
	
	}
}

//function to save changes on production 

function change_proddetail()
{
	$checkauth = $this->checkAuth('prodchange');//authority to action.

	if($checkauth == 0){
		echo 'you are not authorized to do this action';	
		return;
	} else {
		// get all the data and validate things
		$jinput = JFACTORY::getApplication()->input;

		$skey = $this->sanitizeInput($jinput->get('skey','','string'));
		$uscode = $this->sanitizeInput($jinput->get('uscode','','string'));
		$batch_id = $this->sanitizeInput($jinput->get('batch_id','','INT'));
		$saleid = $this->sanitizeInput($jinput->get('saleid','','INT'));
		$ponumber = $this->sanitizeInput($jinput->get('ponumber','','string'));
		$picname = $this->sanitizeInput($jinput->get('picname','','string'));
		//$approver = $this->sanitizeInput($jinput->get('approver','','string'));
		$productname = $this->sanitizeInput($jinput->get('productname','','string'));
		$target = $this->sanitizeInput($jinput->get('target','','string'));
		$startdate = $this->sanitizeInput($jinput->get('startdate','','date'));
		$duedate = $this->sanitizeInput($jinput->get('duedate','','date'));
		$status = $this->sanitizeInput($jinput->get('status','','INT'));
		$remark = $this->sanitizeInput($jinput->get('remark','','string'));
		$connect_sales = $this->sanitizeInput($jinput->get('connect_sales',0,'INT'));

		
		$validate = 1; //default success
		$errmessage = "Terjadi kesalahan: ";
		//validate all fields should be matching
		$pic_id = explode("-",$picname);
		//$approver_id = explode("-",$approver);
		$product_id = explode("-",$productname);

		
		$check_batch_id = $this->validateCompare($batch_id, $this->getColumn('id', '#__ccprodlist', 'published', 1));
		$check_picname = $this->validateCompare($pic_id[0], $this->getColumn('alias', '#__ccempl', 'status', 1));
		//$check_approver = $this->validateCompare($approver_id[0], $this->getColumn('alias', '#__ccauth', 'status', 1));
		$check_productname = $this->validateCompare($product_id[0], $this->getColumn('itemcode', '#__ccsalesmaster', 'published', 1));
		$check_ponumber = $this->validateCompare($ponumber, $this->getColumn('ponumber', '#__ccsales', 'published', 1));

		if($check_batch_id == "" || $check_picname == "" || $check_productname == "" ){
			$validate = 0;
			$errmessage .= " data tidak cocok." . "batch: ". $check_batch_id . "pic: ".$check_picname . "productname: ".$check_productname.
			"PO Number: ".$check_ponumber ;
		}
		
		if($connect_sales == 1){
			//get sales ID to validate sale ID
			$salesID = $this->getValue('salesid', '#__ccsales', 'ponumber', $ponumber);
			
			//get itemcode to validate same items being attached
			$itemcode = $this->getValue('itemcode', '#__ccsalesdetail', 'id', $saleid);
			$check_itemcode = $this->validateCompare($itemcode, $this->getColumn('itemcode', '#__ccsalesmaster', 'itemcode', $product_id[0]));
			
			$check_saleid = $this->validateCompare($saleid, $this->getColumn('id', '#__ccsalesdetail', 'salesid', $salesID));

			if($check_ponumber == "" || $check_saleid =="") 
			{
				$validate = 0;
				$errmessage .=  " PO ". $ponumber." atau nomor Sale ID ".$saleid." tidak ditemukan, atau PO: ".$check_ponumber." dan Sale ID: ".$check_saleid." tidak cocok. ";
			}
			
			if(check_itemcode == ""){
				$validate = 0;
				$errmessage .=  " Item ". $product_id." tidak cocok dengan item menurut Sale ID ".$saleid;		
			}
			
			if($saleid < 1){
			$validate = 0;
			$errmessage .= " sale id tidak diisi, nol atau negatif.";
			}		
		}
		
		if(strlen($check_picname) > 25 || strlen($check_productname) > 35 || strlen($remark) > 254 || strlen($ponumber) > 35){
			$validate = 0;
			$errmessage .= " panjang input tidak sesuai.";
		}
		
		//checking the INTEGERS
		$target = str_replace(",","",$target);
		if($target < 1){
			$validate = 0;
			$errmessage .= " target nol atau negatif.";
		}

		$check_status = $this->validateCompare($status, array(0,1,8));
		$check_connect_sales = $this->validateCompare($connect_sales, array(0,1));

		if(strlen($status) > 2 || $check_status == "" || $check_connect_sales =="" ){
			$validate = 0;
			$errmessage .= " status error.";
		}		

		//checking the DATES
		$check_startdate = $this->validateDate($startdate, 'Y-m-d');
		$check_duedate = $this->validateDate($duedate, 'Y-m-d');
		
		if($check_startdate == "" || $check_duedate == "" ){
			$validate = 0;
			$message .= " tanggal error.";
		}		
		
		//If success, update the data entry
		if($validate == 1){
			
			//prepare the data
			$data = new stdClass();
			$data->pic = $check_picname;
			$data->approver = $this->getValue('alias','#__ccauthsession', 'passwrd', $skey, 'id', ' ASC');
			$data->itemcode = $check_productname;
			$data->target = $target;
			$data->startdate = $startdate;
			$data->duedate = $duedate;
			$data->status = $status;			
			$data->ponumber = $ponumber;
			$data->salesid = $this->getValue('salesid','#__ccsales', 'ponumber', $ponumber);
			//empty salesid if not checked
			if($connect_sales == 0){
			$data->salesid = "";
			}
			$data->saleid = $saleid;
			$data->connect = $connect_sales;

			if($data->status == 1 || $data->status == 8){
				$data->published = 0;	
				
				//update to sales status
				$sales = new stdClass();
				$sales->status = $status;
				$sales->id = $saleid;
				$this->updateOneRow('#__ccsalesdetail', $sales, 'id');

			}
			$data->remark = $remark;
			$data->id = $check_batch_id;			
			//update the data
	//		$this->updateThings($fields, $data, "#__ccprodlist", 'id', $check_batch_id);
			
			$this->updateOneRow('#__ccprodlist', $data,'id');
			//message
			$message = "Pengubahan berhasil";
			$link = JRoute::_('index.php?option=com_ccauth&view=proddetail&skey='.$skey.'&uscode='.$uscode.'&id='.$batch_id);
		} else{
			$message = $errmessage;
			$link = JRoute::_('index.php?option=com_ccauth&view=proddetail&skey='.$skey.'&uscode='.$uscode.'&id='.$batch_id);
		}
	}	
	$mainframe = JFactory::getApplication();	
	$mainframe->redirect($link, $message);
}

	function saveprod()
	{
		$checkauth = $this->checkAuth('authall');//authority to action.
		if($checkauth == 0){
			$message = 'you are not authorized to do this action';	
			$link = JRoute::_('index.php?option=com_ccauth&view=proddetail&skey='.$skey.'&uscode='.$uscode.'&id='.$batch_id);
			return;
		}	else {
			//get data
			$jinput = JFACTORY::getApplication()->input;
			$skey = $this->sanitizeInput($jinput->get('skey','','string'));
			$uscode = $this->sanitizeInput($jinput->get('uscode','','string'));
			$batch_id = $this->sanitizeInput($jinput->get('batch_id','','INT'));
			$approver = $this->sanitizeInput($jinput->get('approver','','string'));

			//validate data
			$validate = 1;
			$errmessage = 'Terjadi kesalahan.';
			//batch ID should be new, not existing.
			$check_batch_id = $this->validateCompare($batch_id, $this->getColumn('id', '#__ccprodlist', '', ''));
			if($check_batch_id != ''){
				$validate = 0;
				$errmessage .= ' Nomor batch ID sudah ada sebelumnya.';
			}
			//approver should be existing.
			$check_picname = $this->validateCompare($approver, $this->getColumn('alias', '#__ccauth', 'status', 1)); //to be changed later
			if($check_picname == ''){
				$validate = 0;
				$errmessage .= ' PIC belum ada.';
			}
			if($validate == 1){
				//save the data if passed validation
				$fields = array('id', 'approver', 'published');
				$datas = array($batch_id, $approver, 1);
				$table = '#__ccprodlist';
				$this->insertRow($fields,$datas,$table);
				
				$link = JRoute::_('index.php?option=com_ccauth&view=proddetail&skey='.$skey.'&uscode='.$uscode.'&id='.$batch_id);
				$message = "Batch ID baru sudah dibuat, silakan isi rincian";
			}
			else{
				$link = JRoute::_('index.php?option=com_ccauth&view=new_prod&skey='.$skey.'&uscode='.$uscode);
				$message = $errmessage;
			}
		}
	$mainframe = JFactory::getApplication();	
	$mainframe->redirect($link, $message);
	}
	public function checkWarehouseAuth($skey, $warehouse){
		$usid = $this->getUserId($skey); //userID
		$db = JFactory::getDbo();
		$query = $db
		->getQuery(true)
		->select('usid')
		->from($db->quoteName('#__ccwarehouseauth')) // change when change table
		->where($db->quoteName('usid') . ' = '.$db->quote($usid))
		->where($db->quoteName('enid') . ' = '.$db->quote($warehouse));
		$db->setQuery($query);
		return $db->loadResult();
	}
	

	function change_outgoing_request(){
		$checkauth = $this->checkAuth('authall');//authority to action.
		if($checkauth == 0){
			$message = 'you are not authorized to do this action';	
			return;
		} else {
			//get data
			$jinput = JFACTORY::getApplication()->input;
			$skey = $this->sanitizeInput($jinput->get('skey','','string'));
			$uscode = $this->sanitizeInput($jinput->get('uscode','','string'));
			$ids = $this->sanitizeInput($jinput->get('id','','string')); // in string, should be changed back to array
			$id = explode("-",$ids); // now array
			$reqs = $this->sanitizeInput($jinput->get('req','','string')); // in string, should be changed back to array
			$req = explode("-",$reqs); // now array
			$enid = $this->sanitizeInput($jinput->get('enid','','string'));
			$statuses = $jinput->get('statuses','',INT); //array cant be sanitized correctly
			$return_link = $this->sanitizeInput($jinput->get('return_link','','string'));
			$update_status = $this->sanitizeInput($jinput->get('update_status','','string'));
	
			//validate data
			$validate = 1;
			$errmessage = 'Terjadi kesalahan.';
			
			//validate the number of IDs
			if(empty($id) || empty($statuses) || empty($req) ){
				$validate = 0;
				$errmessage .= ' Tidak terdapat status yang perlu diubah';
			}
			
			if($enid == "") {
				$validate = 0;
				$errmessage .= ' Tidak terdapat entity ID';
			}
			
			//validate ID and statuses
			$count = count($id);
			for($i = 0; $i < $count ; $i++){
		
				$check_id = $this->validateCompare($id[$i], $this->getColumn('id', '#__ccinvemov', 'published', '1'));
				$check_req = $this->validateCompare($req[$i], $this->getColumn('reqnumber', '#__ccinvemov', 'published', 1));
				$check_stat = $this->validateCompare($this->getValue('status', '#__ccinvemov', 'reqnumber', $req[$i]), array(8,9)); // if already cancelled cannot be changed
				$current_stat = $this->getValue('status', '#__ccinvemov', 'reqnumber', $req[$i]);
				
				if($check_id == ""){
					$validate = 0;
					$errmessage .= ' ID permohonan '.$id[$i].' perpindahan barang tidak ditemukan.';
				}
				if($check_req == ""){
					$validate = 0;
					$errmessage .= ' Request id '.$req[$i].' tidak valid.';
				}
				//if hacked back to request.
				if($statuses[$i] < 0 || $statuses[$i] > 9){
					$validate = 0;
					$errmessage .= ' Status baru tidak valid. Pastikan gudang pengirim telah menyetujui pengiriman.';
				}
				
				//if hacked from request by unauthorized attempt
				
				if($check_stat != ""){
					$validate = 0;
					$errmessage .= ' Terdapat permintaan dengan status '.$req[$i].' sudah closed / dibatalkan. Seluruh perubahan dibatalkan. ';
				}				
			}
			
			//checking for update or not
			if($validate == 1){
				$message = "Perubahan berhasil dilakukan";

				// update the objects one by one
				for($i = 0; $i < $count ; $i++){
					$saveconfirm = 1;
					//get request details
					$request = $this->getOneRow('','#__ccinvemov','reqnumber', $req[$i]);
					//get row of warehouse
					$entityFromID = $this->getValue('id','#__ccwarehouse','enid',$request['entityfrom'],'itemcode',$request['itemcode']); //change inid to itemcode
					$entityFromDetails = $this->getOneRow('','#__ccwarehouse','id',$entityFromID);
					$entityToID = $this->getValue('id','#__ccwarehouse','enid',$request['entityto'],'itemcode',$request['itemcode']);
					$entityToDetails = $this->getOneRow('','#__ccwarehouse','id',$entityToID);

					$enid_out = new StdClass();
					$enid_in = new StdClass();
					
					//set ID
					$enid_out->id = $entityFromID;
					$enid_in->id = $entityToID;
					
					//set data to update outgoing warehouse
					if($request['status'] == 0 && $statuses[$i] != 0){
						$enid_out->outgoing_req = $entityFromDetails['outgoing_req'] - $request['quantity'] ;
						$enid_out->available = $entityFromDetails['available'] - $request['quantity'] ;
						$enid_in->incoming_req = $entityToDetails['incoming_req'] - $request['quantity'] ;
					} 
					if($request['status'] == 1 && $statuses[$i] != 1){
						$enid_out->outgoing_com = $entityFromDetails['outgoing_com'] - $request['quantity'] ;
						$enid_in->incoming_com = $entityToDetails['incoming_com'] - $request['quantity'] ;
					} 
					if($request['status'] == 2 && $statuses[$i] != 2){
						$enid_out->outgoing_del = $entityFromDetails['outgoing_del'] - $request['quantity'] ;
						$enid_in->incoming_del = $entityToDetails['incoming_del'] - $request['quantity'] ;
					} 
					if($request['status'] == 3 && $statuses[$i] != 3){
						$enid_out->outgoing_con = $entityFromDetails['outgoing_con'] - $request['quantity'] ;
						$enid_in->incoming_con = $entityToDetails['incoming_con'] - $request['quantity'] ;
					} 
					
					//set data to update incoming warehouse
					if($statuses[$i] == 0 && $request['status'] != 0){
						$enid_out->outgoing_req = $entityFromDetails['outgoing_req'] + $request['quantity'] ;
						$enid_in->incoming_req = $entityToDetails['incoming_req'] + $request['quantity'] ;
					} 
					if($statuses[$i] == 1 && $request['status'] != 1){
						$enid_out->outgoing_com = $entityFromDetails['outgoing_com'] + $request['quantity'] ;
						$enid_in->incoming_com = $entityToDetails['incoming_com'] + $request['quantity'] ;
					}
					
					if($statuses[$i] == 2 && $request['status'] != 2){
						$enid_out->outgoing_del = $entityFromDetails['outgoing_del'] + $request['quantity'] ;
						$enid_in->incoming_del = $entityToDetails['incoming_del'] + $request['quantity'] ;
					}
					if($statuses[$i] == 3 && $request['status'] != 3){
						$enid_out->outgoing_con = $entityFromDetails['outgoing_con'] + $request['quantity'] ;
						$enid_in->incoming_con = $entityToDetails['incoming_con'] + $request['quantity'] ;
					}
					if($statuses[$i] == 8){
						$enid_out->available = $entityFromDetails['available'] + $request['quantity'] ;
					}
					if($statuses[$i] == 8 && $request['status'] == 0){
						$enid_out->available = $entityFromDetails['available'] ;
					}
					if($statuses[$i] == 9){
						//check authority, success delivery should be done by outgoing and incoming authorized personnel.
						$checkwareauth = $this->checkWarehouseAuth($skey, $request['entityto']); // authority to change status
						if($checkwareauth != ""){
						$enid_in->available = $entityToDetails['available'] + $request['quantity'] ;
						} else {
							$saveconfirm = 0; //abort changes
							$errmessage = "Override hanya boleh dilakukan oleh user dengan hak akses di Gudang Penerima";
						}
					}
					
					if($saveconfirm == 1){
					//update the warehouse
					
					$this->updateOneRow( '#__ccwarehouse', $enid_out, 'id');
					$this->updateOneRow( '#__ccwarehouse',$enid_in, 'id');

					//update invemov
					$data = new StdClass();
					$data->id = $id[$i];
					$data->status = $statuses[$i];
					$this->updateOneRow('#__ccinvemov', $data, 'id');
					}
					else{
						$message = "Perubahan dibatalkan. ". $errmessage;
					}
				}
				
				
				//update status if asked - consider ubah, supaya berdasarkan data yang diubah saja, bukan dari hasil form
				if($update_status!="" ){
					if($saveconfirm == 1){
						$status = explode("|", $update_status);
		
						$data = new stdClass();
						$data->ref = $status[3];
						if($status[2]==1){
						$current_value = $this->getValue("retur", "#__ccsalesdetail", "ref", $status[3]);
						$new_value = $current_value + $status[1];
						$data->retur = $new_value;
						}else{
						$current_value = $this->getValue("sent", "#__ccsalesdetail", "ref", $status[3]);
						$new_value = $current_value + $status[1];
						$data->sent = $new_value;
						}
					//	$data->achievement = json_encode($new_array);
						$this->updateOneRow( '#__ccsalesdetail',$data, 'ref');
					}
				}
				
			} else {
				//some error occurred
				$errmessage .= ' Update dibatalkan.';
				$message = $errmessage;
			}			
			
			$link = JRoute::_('index.php?option=com_ccauth&view=stock_list&skey='.$skey.'&uscode='.$uscode.'&id='.$enid);
		}
		$mainframe = JFactory::getApplication();	
		if($return_link!=""){
			$returns = explode(",",$return_link);
			$link =  JRoute::_('index.php?option='.$returns[0].'&view='.$returns[1].'&uscode='.$uscode.'&skey='.$skey.'&'.$returns[2].'='.$returns[3]);
		}
		$mainframe->redirect($link, $message);
	}

	
	function updateproduksi()
	{
		//this function updates realization of production in the batch (table prodlist). 
		//This function will also update daily production (in batches as entity). This table is for summary and reporting purposes.
		$checkauth = $this->checkAuth('produpdate');//authority to action.
		if($checkauth == 0){
			$message = 'you are not authorized to do this action';	
			return;
		} else {
			//get data
			$jinput = JFACTORY::getApplication()->input;
			$skey = $this->sanitizeInput($jinput->get('skey','','string'));
			$uscode = $this->sanitizeInput($jinput->get('uscode','','string'));
			$batch_id = $this->sanitizeInput($jinput->get('batch_id','','INT'));
			$update = $this->sanitizeInput($jinput->get('update',0,'INT'));
			$date = $this->sanitizeInput($jinput->get('date','','date'));
			$itemcode = $this->getValue("itemcode", "#__ccprodlist", "id", $batch_id);

			//validate data
			$validate = 1;
			$errmessage = 'Terjadi kesalahan.';
			
			//batch ID should be existing.
			$check_batch_id = $this->validateCompare($batch_id, $this->getColumn('id', '#__ccprodlist', '', ''));
			if($check_batch_id == ''){
				$validate = 0;
				$errmessage .= ' Nomor batch ID sudah tidak ada.';
			}
			
			//get dates from prodlist and achievement, date should not be existing.
			$existing = $this->getValue("achievement", "#__ccprodlist", "id", $batch_id);
			$realisasi = 0; //set default number to update the table.
			if($existing !="")
				{
				$achievements = json_decode($existing,true);
				$keys = array_keys($achievements);
				$check_date = $this->validateCompare($date,$keys);
				}
			if($check_date != ''){
				$validate = 0;
				$errmessage .= ' Tanggal sudah ada.';
			}
			//validate update
			if($update < 1){
				$validate = 0;
				$errmessage .= ' Nilai update tidak valid';
				$errmessage .= 'existing : '. ($existing);
			}
			
			// prepare the data
			if($validate == 1){
				//prepare new data
				$update_array = array($date=>$update);
				if($existing !="")
					{
					$new_array = array_merge($achievements, $update_array);
					ksort($new_array);
					//$new_array = ksort($new_array);
					$realisasi += array_sum($achievements) + $update;
					}
					else{
					$new_array = $update_array;	
					$realisasi += $update;
					}
				//update the data
				$data = new stdClass();
				$data->id = $batch_id;
				$data->realisasi = $realisasi;
				$data->achievement = json_encode($new_array);
				$this->updateOneRow( '#__ccprodlist',$data, 'id');
				
				//update the table is for summary and reporting, table proddates
				$summary = new stdClass();
				//$summary->batch_id = $batch_id;
				$summary->date = $date;
				$summary->itemcode = $itemcode;
				$summary->published = 1;
				$existing = $this->getValue("id", "#__ccproddates", "date", $date, "itemcode", $itemcode);
				if($existing !=""){
				$existing_number = $this->getValue("produksi", "#__ccproddates", "id", $existing);
				$summary->produksi = $update + $existing_number;
				$summary->id = $existing;
				$this->updateOneRow('#__ccproddates', $summary,  'id');
				} else{				
				$summary->produksi = $update;
				$execute = JFactory::getDbo()->insertObject('#__ccproddates', $summary);
				}

				$message = 'Update berhasil dilakukan';
				$link = JRoute::_('index.php?option=com_ccauth&view=proddetail&skey='.$skey.'&uscode='.$uscode.'&id='.$batch_id);
			}else{
				$message = $errmessage;
				$link = JRoute::_('index.php?option=com_ccauth&view=produpdate&skey='.$skey.'&uscode='.$uscode.'&id='.$batch_id);
			}
		}
		$mainframe = JFactory::getApplication();	
		$mainframe->redirect($link, $message);
	}
	
	//************				Versi 1.03 Inventory

	function change_bom()
	{
		//prepare data and sanitize / validate
		$checkauth = $this->checkAuth('authall');//authority to action.
		if($checkauth == 0){
			$message = 'you are not authorized to do this action';	
			return;
		}	else {
			//get data
			$jinput = JFACTORY::getApplication()->input;
			$skey = $this->sanitizeInput($jinput->get('skey','','string'));
			$uscode = $this->sanitizeInput($jinput->get('uscode','','string'));
			$inid = $this->sanitizeInput($jinput->get('batch_id','','INT'));
			$new_items = $jinput->get('items','','string');//array
			$new_quan = $jinput->get('quan','','INT');//array
		
			//check validity of data
			$validate = 1;
			$errmessage = "Terjadi Kesalahan. ";
			
			//check the batch_id
			$check_inid = $this->validateCompare($inid, $this->getColumn('id','#__ccsalesmaster'));
			
			if($check_inid==""){
				$validate = 0;
				$errmessage .= " ID Item tidak dikenali";
			}
			
			if($validate == 1){
				//get existing field, decode, add, then encode.
				$data->id = $check_inid;
				$add = "{";
				$check_keys = array();
				//check new_itemcode
				for($i=0;$i<count($new_items);$i++)
				{
					//validate the referred items.
					$item = explode('-',$this->sanitizeInput($new_items[$i]));
					$check_item = $this->validateCompare($item[0], $this->getColumn('itemcode','#__ccsalesmaster', 'status',1));
					$id = $this->getValue('id', '#__ccsalesmaster', 'itemcode', $check_item);
					if($this->sanitizeInput($new_quan[$i])>0 && $check_item!="")
					{
						$check = $this->validateCompare($id, $check_keys);
						if($check==""){	
							$add .= '"'.$id.'":"'.$new_quan[$i].'",';
							array_push($check_keys, $id);
						}
					}										
				}
				$add = chop($add, ",");
				$add .= "}";
				
				$data->bom = $add;
				//update the bom
				$this->updateOneRow('#__ccsalesmaster',$data,  'id');
				$message = 'Perubahan BOM telah berhasil'.$add;
//				$message = print_r($update);

			}
			else{

				$message = $errmessage;
			}
			//compare batch_id
			$link = JRoute::_('index.php?option=com_ccauth&view=invemaintain&skey='.$skey.'&uscode='.$uscode.'&id='.$inid);
			//compare items		
		}
		$mainframe = JFactory::getApplication();	
		$mainframe->redirect($link, $message);
		//if success store, otherwise send error message and return to same page.
		
	}
	//************				Versi 1.03 Inventory

	
	function submit_change()	
	{
	
	$checkauth = $this->checkAuth('saveitemsale');//authority to action.
		
	if($checkauth == 0){
		echo 'you are not authorized to do this action';	
		return;
		}
	else {
		$jinput = JFACTORY::getApplication()->input;
		
			//************* INPUTS VALIDATION *************//

			$validate = 1;//default success
			//$message = JText::_('COM_CCJOURNAL_SUCCESSFUL_POST');//default message - cc component change

			// get and sanitize the authentication keys, salesids and items (item ids in strings, remarks 0 - 2, and status 0 - 2) within.
			$skey = $this->sanitizeInput($jinput->get('skey','','string'));
			$uscode = $this->sanitizeInput($jinput->get('uscode','','string'));
			$salesid = $this->sanitizeInput($jinput->get('salesid','','string'));
			$ids = $this->sanitizeInput($jinput->get('ids','','string'));
			
			$remark0 = $this->sanitizeInput($jinput->get('remark_0','','string'));
			$remark1 = $this->sanitizeInput($jinput->get('remark_1','','string'));
			$remark2 = $this->sanitizeInput($jinput->get('remark_2','','string'));
			$remark3 = $this->sanitizeInput($jinput->get('remark_3','','string'));
			$remark4 = $this->sanitizeInput($jinput->get('remark_4','','string'));

			//add more
			
			
			$status0 = $this->sanitizeInput($jinput->get('status_0','','INT'));
			$status1 = $this->sanitizeInput($jinput->get('status_1','','INT'));
			$status2 = $this->sanitizeInput($jinput->get('status_2','','INT'));
			$status3 = $this->sanitizeInput($jinput->get('status_3','','INT'));
			$status4 = $this->sanitizeInput($jinput->get('status_4','','INT'));			

			//add more
			$iditems = explode("-",$ids);
			$count = count($iditems);
			
			$sortitems = array();
			if($count > 0){
				$sortitems[] = $status0;
				$count = $count - 1;
			}			
			if($count > 0){
				$sortitems[] = $status1;
				$count = $count - 1;				
			}
			if($count > 0){
				$sortitems[] = $status2;				
				$count = $count - 1;
			}
			if($count > 0){
				$sortitems[] = $status3;				
				$count = $count - 1;
			}
			if($count > 0){
				$sortitems[] = $status4;				
				$count = $count - 1;
			}
			
			$iditems = explode("-",$ids);
			
			//************* COMPARE SOME INPUTS  **********************//
			// validate sales items match with correspond sales IDs.
			foreach($iditems as $iditem){
				$find_id = $this->validateCompare($iditem, $this->getColumn('id','#__ccsalesdetail','salesid',$salesid));
				$match = 0; //default error
				if(!empty($find_id)){
					$match = 1; // identifier of failed verification
				}
			}
			
			//************* CHECK INPUT LIMITS  **********************//
			
			function fieldpass($salesid, $remark, $status){
				
				$field_pass = 0; //default value if no match
				
				if($status <0 || $status > 9) {
				$field_pass = 1;
				}
				if(strlen($status) > 2 || strlen($remark) > 99 || strlen($salesid) >12) {
				$field_pass = 2;
				}
				return $field_pass;
			}
			
			$field_pass = $field_pass + fieldpass($salesid,$remark0,$status0); 
			$field_pass = $field_pass + fieldpass($salesid,$remark1,$status1); 
			$field_pass = $field_pass + fieldpass($salesid,$remark2,$status2); 
			$field_pass = $field_pass + fieldpass($salesid,$remark3,$status3); 
			$field_pass = $field_pass + fieldpass($salesid,$remark4,$status4); 
			// **** continue to add as necessary
					
			//************* SORT ITEMS **********************//
			
			$sales_status = array($status0, $status1, $status2, $status3, $status4);
			sort($sortitems);
	
			//*************FINAL VALIDATION***************//	
			if($salesid == "" || $match == 0 || $field_pass > 0 ){
				$validate = 0;
				$message = JText::_('COM_CCJOURNAL_INVALID_ENTRY') . '<br/>'.
				'salesID: '.$salesid .
				'match: '.$match .
				'field pass status: '.$field_pass
				
				; //default message - cc component change
			//debug only
			}
			
			//success, then post result
			if($validate == 1){
				//prepare function
				
				
				/******* FUNCTION *******/
				
				function updateThings($field, $data, $table, $criteria1, $value1, $criteria2, $value2){
					$db = JFactory::getDbo();
					$query = $db->getQuery(true);

					// Fields to update.
					$fields = 
					$db->quoteName($field) . ' = ' . $db->quote($data); // field name and data

					// Conditions for which records should be updated.
					$conditions = array(
					$db->quoteName($criteria1) . ' = '. $db->quote($value1), //$criteria1 and value1 matching test
					$db->quoteName($criteria2) . ' = '. $db->quote($value2)); // criteria2 and value 2 matching test

					$query->update($db->quoteName($table))->set($fields)->where($conditions);  // table name 
					$db->setQuery($query);
					$result = $db->execute();
				}
				
				//update salesdetail table 
				updateThings('remark', $remark0, '#__ccsalesdetail', 'salesid', $salesid, 'id', $iditems[0]);				
				updateThings('remark', $remark1, '#__ccsalesdetail', 'salesid', $salesid, 'id', $iditems[1]);
				updateThings('remark', $remark2, '#__ccsalesdetail', 'salesid', $salesid, 'id', $iditems[2]);
				updateThings('remark', $remark3, '#__ccsalesdetail', 'salesid', $salesid, 'id', $iditems[3]);
				updateThings('remark', $remark4, '#__ccsalesdetail', 'salesid', $salesid, 'id', $iditems[4]);
				updateThings('status', $status0, '#__ccsalesdetail', 'salesid', $salesid, 'id', $iditems[0]);
				updateThings('status', $status1, '#__ccsalesdetail', 'salesid', $salesid, 'id', $iditems[1]);
				updateThings('status', $status2, '#__ccsalesdetail', 'salesid', $salesid, 'id', $iditems[2]);	
				updateThings('status', $status3, '#__ccsalesdetail', 'salesid', $salesid, 'id', $iditems[3]);	
				updateThings('status', $status4, '#__ccsalesdetail', 'salesid', $salesid, 'id', $iditems[4]);	
				
				//update sales table
				updateThings('status', $sales_status[0], '#__ccsales', 'salesid', $salesid, 'salesid', $salesid);				

				// **** continue to add as necessary
			}
			
			else { 
			//do nothing
			}
			//route back
			
			if($salesid == ""|| $skey == ""|| $uscode == ""){
				$link = JRoute::_('index.php?option=com_ccauth&view=logon');
			}
			else{
				$link = JRoute::_('index.php?option=com_ccauth&view=konfirmasi&skey='.$skey.'&uscode='.$uscode.'&salesid='.$salesid);
				$message = "Perubahan status dan catatan berhasil dilakukan";
				
				//post audit trail		
				$username = $this->getUsername($skey);
				$fields = array('published', 'status', 'remark');
				
				$datas = array(1,1,'Submit Change|SalesItem|'.$salesid.'|'.$iditems[0].'|'.$status0.'|'.$iditems[1].'|'.$status1.'|'.$iditems[2].'|'.$status2.'|'.$iditems[3].'|'.$status3.'|'.$iditems[4].'|'.$status4.'|'.$username);
				$table = '#__ccsalestrail';
				//to post
				$this->insertRow($fields,$datas,$table);
			}
			
			$mainframe = JFactory::getApplication();
			
			//call email function
			//$sent = $this->_sendEmail();
			
			$mainframe->redirect($link, $message);
	}
}	


// function sales new

function chg_pass()	
	{
		$checkauth = $this->checkAuth('authall');//authority to action.
		
		if($checkauth == 0){
		echo 'you are not authorized to do this action';
		
		return;
		}
		else{
		
		$jinput = JFACTORY::getApplication()->input;
	
		$data = new stdClass();
		$data->usid = $this->sanitizeInput($jinput->get('usid','','string'));
		$data->passwd = $this->sanitizeInput($jinput->get('passwd','','string'));
		$data->passwd1 = $this->sanitizeInput($jinput->get('n_passwd1','','string'));
		$data->passwd2 = $this->sanitizeInput($jinput->get('n_passwd2','','string'));
		$data->uscode = $this->sanitizeInput($jinput->get('uscode','','string'));
		$data->skey = $this->sanitizeInput($jinput->get('skey','','string'));
		
		//validation process
		$validate = 1;//default success
		$message = "Password was succesfully changed";//default message - cc component change
		$errmessage = "Terjadi Kesalahan. ";
		
		// check if empty		
		if($data->usid == "" || $data->passwd == "" || $data->passwd1 == "" || $data->passwd2 == "" ){
			$validate = 0;
			$errmessage .= JText::_('COM_CCINVE_INVALID_EMPTY_NAME'); //default message - cc component change
		}
		
		//check if exceed max length
		if(strlen($data->usid) > 12 || strlen($data->passwd) >25 || strlen($data->passwd1) > 25 ){ 
			$validate = 0;
			$errmessage .= "New Passwords is too long, max 25 chars";
		}
		
		//check if new passwords are consistent
		if($data->passwd1 != $data->passwd2 ){ 
			$validate = 0;
			$errmessage .= "New Passwords don't match";
		}		
		
		//check if new passwords too short
		if(strlen($data->passwd1) < 6 ){ 
			$validate = 0;
			$errmessage .= "New Password is too short, minimum 6 chars";
		}
		//check if new password is same with old one.
		if($data->passwd1 == $data->passwd2 &&  $data->passwd == $data->passwd2 && $data->passwd2 !=""){ 
			$validate = 0;
			$errmessage .= "New password should be different from current password";
		}				
		//check if old password is correct
		function getUsid($usid, $passwd, $skey) {
			$db = JFactory::getDbo();
			$query = $db->getQuery(true);
			$query->select($db->quoteName('a.uscode')); //change field
			$query->from($db->quoteName('#__ccauth', 'a')); // change when change table
			$query->join('INNER', $db->quoteName('#__ccauthsession', 'b') . ' ON (' . $db->quoteName('a.usid') . ' = ' . $db->quoteName('b.usid') . ')');
					
			// here is the matching criteria:  
			$query->where($db->quoteName('a.usid') . ' = '. $db->quote($usid));
			$query->where($db->quoteName('a.passwrd') . ' = '. $db->quote($passwd));
			$query->where($db->quoteName('b.passwrd') . ' = '. $db->quote($skey));
					 
			$db->setQuery($query);
			$results = $db->loadResult(); //single data query
					
			return $results;
		}
		
		//seek for password match
		$hash = sha1($data->passwd);

		$check = getUsid($data->usid, $hash, $data->skey);
		
		//found, not empty
		if($check == ""){
		$validate = 0;
		$message = "Old Password doesnt match ";	
		}
		
		if($validate == 1){
		//success, then update password
			
			
			$db = JFactory::getDbo();
			$query = $db->getQuery(true);

			$hash = sha1($data->passwd1);

			// Fields to update.
			$fields = 
			$db->quoteName('passwrd') . ' = ' . $db->quote($hash);

			// Conditions for which records should be updated.
			$conditions = array(
			$db->quoteName('usid') . ' = '. $db->quote($data->usid),
			$db->quoteName('uscode') . ' = '. $db->quote($data->uscode));

			$query->update($db->quoteName('#__ccauth'))->set($fields)->where($conditions);

			$db->setQuery($query);

			$result = $db->execute();
			
			//set session and create new session
			$nhash = sha1($data->passwd1); //patch later for more security			
			$random = rand(10,10000);// create random key for session
			$nskey = sha1($random.substr($hash, -15,15));   

			$session = $db->getQuery(true);

			// Fields to update.
			$fields = array(
			$db->quoteName('passwrd') . ' = ' . $db->quote($nskey),
			$db->quoteName('random') . ' = ' . $db->quote($random)
			);

			// Conditions for which records should be updated.
			$conditions = array(
			$db->quoteName('usid') . ' = '.$db->quote($data->usid) ,
			$db->quoteName('uscode') . ' = '.$db->quote($data->uscode)
			);

			$session->update($db->quoteName('#__ccauthsession'))->set($fields)->where($conditions);
			$db->setQuery($session);
			$result = $db->execute();
			
		
			$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view=home&uscode='.$data->uscode.'&skey='.$nskey);		
		}
		else{
			$message = $errmessage;
			$link = \Joomla\CMS\Router\Route::_('index.php?option=com_ccauth&view=chgpas&uscode='.$data->uscode.'&skey='.$data->skey);
		}
		
		//route back
		$mainframe = JFactory::getApplication();
		$mainframe->redirect($link, $message);
		}
	}
				
	function sale_detail_change(){
		//validate action
		$checkauth = $this->checkAuth('authall');//authority to action.
		
		if($checkauth == 0){
			$message = 'you are not authorized to do this action';	
		} 
		else {
		//get all data
			$jinput = JFACTORY::getApplication()->input;
			$skey = $this->sanitizeInput($jinput->get('skey','','string'));
			$uscode = $this->sanitizeInput($jinput->get('uscode','','string'));
			$ref = $this->sanitizeInput($jinput->get('ref','','string'));
			$jnref = $this->sanitizeInput($jinput->get('jnref','','string'));
			$price = $this->sanitizeInput($jinput->get('price','',INT));
			$quantity = $this->sanitizeInput($jinput->get('quantity','',INT));
			$remark = $this->sanitizeInput($jinput->get('remark','','string'));
			
			//make necessary validations
			$validate = 1;
			$message = "Perubahan berhasil";
			$errmessage = "Terjadi Kesalahan. ";
			
			$check_ref = $this->validateCompare($ref, $this->getColumn('ref','#__ccsalesdetail','active',1));		
			$check_jnref = $this->validateCompare($jnref, $this->getColumn('salesid','#__ccsalesdetail','active',1));		
			$check_status = $this->getValue('status','#__ccsalesdetail', 'ref', $ref);

			if($quantity == 0 && $price == 0 && $remark == ""){
				$validate = 0;
				$errmessage .= "Tidak ada perubahan yang di-submit";
			}
			
			if($check_ref =="" || $check_jnref ==""){
				$validate = 0;
				$errmessage .= "Referensi pembelian tidak ditemukan. ";
			}
			if($check_status !=0 ){
				$validate = 0;
				$errmessage .= "PO sudah tidak berstatus OPEN. ";
			}
			if($price < 0){
				$validate = 0;
				$check_price = 0;
				$errmessage .= "Harga tidak boleh kurang dari nol. ";
			}

			if($quantity < 0){
				$validate = 0;
				$check_quantity = 0;	
				$errmessage .= "Kuantitas tidak boleh kurang dari nol. ";
			}
			
			if(strlen($remark) > 99){
				$validate = 0;				
				$check_remark = 0;
				$errmessage .= "Keterangan tidak boleh lebih dari 99 karakter. ";
			}

			//Jika lolos validasi simpan 
			if($validate == 0){
				$message = $errmessage;
			}
			else{
			//lakukan update pada purcdetail
			$data = new stdClass;
			$data->ref = $ref;
			if($price > 0){
				$data->price = $price;
			}
			if($quantity > 0){
				$data->quantity = $quantity;
			}
			if($remark != ""){
				$data->remark = $remark;
			}
			
			$this->updateOneRow('#__ccsalesdetail', $data, 'ref');
			}
		}
		
		$link = JRoute::_('index.php?option=com_ccauth&view=konfirmasi&uscode='.$uscode.'&skey='.$skey.'&salesid='.$jnref);
		//route back
		$mainframe = JFactory::getApplication();
		$mainframe->redirect($link, $message);
	}
	
	function sale_close(){
		//validate action
		$checkauth = $this->checkAuth('authall');//authority to action.
		
		if($checkauth == 0){
			$message = 'you are not authorized to do this action';	
		} 
		else {
		//get all data
			$jinput = JFACTORY::getApplication()->input;
			$skey = $this->sanitizeInput($jinput->get('skey','','string'));
			$uscode = $this->sanitizeInput($jinput->get('uscode','','string'));
			$ref = $this->sanitizeInput($jinput->get('ref','','string'));
			$liable = str_replace(",","",$jinput->get('eligible'));
			$liable = $this->sanitizeInput($liable);
			$jnref = $this->sanitizeInput($jinput->get('jnref','','string'));

			//make necessary validations
			$validate = 1;
			$message = "PO telah ditutup";
			$errmessage = "Terjadi Kesalahan .";
			
			$check_ref = $this->validateCompare($ref, $this->getColumn('ref','#__ccsalesdetail','active',1));		
			$check_status = $this->getValue('status','#__ccsalesdetail', 'ref', $ref);
			$check_collect_ref = $this->getValue('active','#__ccsale_collect','ref',$ref);
			
			if($check_ref ==""){
				$validate = 0;
				$errmessage .= "Referensi pembelian tidak ditemukan. ";
			}
			
			//check liable			
			if($liable < 0 ){
				$validate = 0;
				$errmessage .= "Nilai Tagihan tidak boleh lebih kecil dari nol";
			}
			
			if($check_status !=0 ){
				$validate = 0;
				$errmessage .= "PO sudah tidak berstatus OPEN. ";
			}
			
			//Jika lolos validasi simpan 
			if($validate == 0){
				$message = $errmessage;
			}
			else{
			//lakukan update pada purcdetail
			$data = new stdClass;
			$data->ref = $ref;
			$data->eligible = $liable;
			$data->status = 1;

			$this->updateOneRow('#__ccsalesdetail', $data, 'ref');
			
			if($check_collect_ref==0 || $check_collect_ref=="" ){
			//lakukan insert pada ccpur_pay utk penjualan yang sudah ready dibayar.
			$customer = $this->getValue('customer', '#__ccsalesdetail', 'ref', $ref);
			$itemcode = $this->getValue('itemcode', '#__ccsalesdetail', 'ref', $ref);
			$sent = $this->getValue('sent', '#__ccsalesdetail', 'ref', $ref);
			$retur = $this->getValue('retur', '#__ccsalesdetail', 'ref', $ref);
			$price = $this->getValue('price', '#__ccsalesdetail', 'ref', $ref);

			$date = date("Y-m-d");//now
			$remark = "Penagihan PO Ref ".$ref." untuk penjualan ".$itemcode.", terkirim ".$sent.", retur ".$retur.", @ ".$price;
		
			$fields = array('ref', 'eligible', 'collect_ref', 'collect_date', 'customer', 'remark', 'status', 'active');
			$datas = array($ref, $liable, $ref, $date, $customer, $remark, 1, 1);
			$table = '#__ccsale_collect';
			$this->insertRow($fields,$datas,$table);
			}else{
			//update collect
			$collect = new stdClass;
			$collect->eligible = $liable;
			$collect->ref = $ref;
			
			$this->updateOneRow('#__ccsale_collect', $collect, 'ref');
			$message .= " Nilai Penagihan telah di-update.";
			}
			// Pengecekan pada semua items dalam satu PO, jika sudah semua closed, maka update status PO
			$statuses = $this->getColumn('status','#__ccsalesdetail','salesid',$jnref);
			$change = 1;
				foreach($statuses as $status){
					if($status != 1){
						$change = 0;//no change to status
					}
				}
				if($change == 1){
					$sales = new stdClass;
					$sales->status = 2;
					$sales->salesid = $jnref;
					$this->updateOneRow('#__ccsales', $sales, 'salesid');
				}
			}
		}
		$link = JRoute::_('index.php?option=com_ccauth&view=konfirmasi&uscode='.$uscode.'&skey='.$skey.'&salesid='.$jnref);
		//route back
		$mainframe = JFactory::getApplication();
		$mainframe->redirect($link, $message);
	}
	
	function create_invoice(){
		//validate action
		$checkauth = $this->checkAuth('authall');//authority to action.
		
		if($checkauth == 0){
			$message = 'you are not authorized to do this action';	
		} 
		else {
		//get all data
			$jinput = JFACTORY::getApplication()->input;
			$skey = $this->sanitizeInput($jinput->get('skey','','string'));
			$uscode = $this->sanitizeInput($jinput->get('uscode','','string'));
			$ref = $this->sanitizeInput($jinput->get('ref','','string'));
			$liable = str_replace(",","",$jinput->get('eligible'));
			$liable = $this->sanitizeInput($liable);
			$jnref = $this->sanitizeInput($jinput->get('jnref','','string'));
			$return_link = $jinput->get('return_link','','string'); //array
			
			//make necessary validations
			$validate = 1;
			$message = "Invoice telah dibuat";
			$errmessage = "Terjadi Kesalahan .";
			
			$check_ref = $this->validateCompare($ref, $this->getColumn('ref','#__ccsalesdetail','active',1));		
			$check_status = $this->getValue('status','#__ccsalesdetail', 'ref', $ref);
			$check_collect_ref = $this->getValue('active','#__ccsale_collect','ref',$ref);

			if($check_ref ==""){
				$validate = 0;
				$errmessage .= "Referensi pembelian tidak ditemukan. ";
			}
			
			//check liable			
			if($liable < 0 ){
				$validate = 0;
				$errmessage .= "Nilai Tagihan tidak boleh lebih kecil dari nol";
			}
			
			if($check_status !=0 ){
				$validate = 0;
				$errmessage .= "PO sudah tidak berstatus OPEN. ";
			}
			
			//Jika lolos validasi simpan 
			if($validate == 0){
				$message = $errmessage;
			}
			else{
			//lakukan update pada purcdetail
			$data = new stdClass;
			$data->ref = $ref;
			$data->eligible = $liable;
			//$data->status = 1; this one wont close the sales.

			$this->updateOneRow('#__ccsalesdetail', $data, 'ref');
			
			if($check_collect_ref==0 || $check_collect_ref=="" ){
			//lakukan insert pada ccpur_pay utk penjualan yang sudah ready dibayar.
			$customer = $this->getValue('customer', '#__ccsalesdetail', 'ref', $ref);
			$itemcode = $this->getValue('itemcode', '#__ccsalesdetail', 'ref', $ref);
			$received = $this->getValue('sent', '#__ccsalesdetail', 'ref', $ref);
			$retur = $this->getValue('retur', '#__ccsalesdetail', 'ref', $ref);
			$price = $this->getValue('price', '#__ccsalesdetail', 'ref', $ref);

			$date = date("Y-m-d");//now
			$remark = "Penagihan PO Ref ".$ref." untuk penjualan ".$itemcode.", terkirim ".$received.", retur ".$retur.", @ ".$price;
		
			$fields = array('ref', 'eligible', 'collect_ref', 'collect_date', 'customer', 'remark', 'status', 'active');
			$datas = array($ref, $liable, $ref, $date, $customer, $remark, 1, 1);
			$table = '#__ccsale_collect';
			$this->insertRow($fields,$datas,$table);
			}else{
			//update collect
			$collect = new stdClass;
			$collect->eligible = $liable;
			$collect->ref = $ref;
			
			$this->updateOneRow('#__ccsale_collect', $collect, 'ref');
			$message .= " Nilai Penagihan telah di-update.";
			}
			
			// Pengecekan pada semua items dalam satu PO, jika sudah semua closed, maka update status PO
			$statuses = $this->getColumn('status','#__ccsalesdetail','salesid',$jnref);
			$change = 1;
			foreach($statuses as $status){
				if($status != 1){
					$change = 0;//no change to status
				}
			}
			if($change == 1){
				$data = new stdClass;
				$data->status = 2;
				$data->salesid = $jnref;
				$this->updateOneRow('#__ccsales', $data, 'jnref');
			}

			}
		}
		$link = JRoute::_('index.php?option=com_ccauth&view=konfirmasi&uscode='.$uscode.'&skey='.$skey.'&salesid='.$jnref);
			
		if($return_link!=""){
			$returns = explode(",",$return_link);
			$link =  JRoute::_('index.php?option='.$returns[0].'&view='.$returns[1].'&uscode='.$uscode.'&skey='.$skey.'&'.$returns[2].'='.$returns[3]);
		}
		
		//route back
		$mainframe = JFactory::getApplication();
		$mainframe->redirect($link, $message);
	}
	
	
function add_receiving_payment(){
		//validate action
		$checkauth = $this->checkAuth('authall');//authority to action.
		
		if($checkauth == 0){
			$message = 'you are not authorized to do this action';	

			} else {
		//get all data
			$jinput = JFACTORY::getApplication()->input;
			$skey = $this->sanitizeInput($jinput->get('skey','','string'));
			$uscode = $this->sanitizeInput($jinput->get('uscode','','string'));
			//$ref = $this->sanitizeInput($jinput->get('ref','','string'));
			$collect_ref = $this->sanitizeInput($jinput->get('collect_ref','','string'));
			$paynow = str_replace(",","",$jinput->get('paynow'));
			$paynow = $this->sanitizeInput($paynow);
			$type = $this->sanitizeInput($jinput->get('type'));
			$date = $this->sanitizeInput($jinput->get('date','','date'));
			$remark = $this->sanitizeInput($jinput->get('remark','','string'));
			$usid = $this->sanitizeInput($jinput->get('usid','','string'));

		//make necessary validations
			$validate = 1;
			$message = "Pencatatan penagihan berhasil dilakukan. ";
			$errmessage = "Terjadi Kesalahan .";
			
			if($paynow<=1){
				$validate = 0;
				$errmessage .= "Penagihan tidak boleh nol atau kurang. ";
			}

			$check_date = $this->validateDate($date, 'Y-m-d');
			if($check_date==""){
				$validate = 0;
				$errmessage .= "Tanggal tidak terisi dengan benar. ";		
			}
			
			$check_type = $this->validateCompare($type, $this->getColumn('code', '#__ccpaymentmaster', 'active', 1)); 			
			if($check_type==""){
				$validate = 0;
				$errmessage .= "Tujuan pembayaran ".$type." tidak ditemukan. ";		
			}	
			
			$check_collect_ref = $this->validateCompare($collect_ref, $this->getColumn('collect_ref', '#__ccsale_collect', 'active', 1)); 			
			if($check_collect_ref==""){
				$validate = 0;
				$errmessage .= "Referensi Pembayaran ".$collect_ref." tidak ditemukan. ";		
			}		
			
		//if no error then post to database
			if($validate == 1){
				//prepare data
			
				$fields = array('payment', 'collect_ref', 'collect_date', 'payment_type','remark', 'active');
				$datas = array($paynow, $collect_ref, $date, $type, $remark, 1);
				$table = '#__ccsale_collect_details';
				$this->insertRow($fields,$datas,$table);

			} else {
				// theres error, do nothing.
				$message = $errmessage;
			}
		}
		$link = JRoute::_('index.php?option=com_ccauth&view=collectdetail&uscode='.$uscode.'&skey='.$skey.'&id='.$collect_ref);
		$mainframe = JFactory::getApplication();
		$mainframe->redirect($link, $message);
	}
				
private function _sendEmail()
	{
		$jinput = JFACTORY::getApplication()->input;
	
		$data = new stdClass();
		$data->email = $jinput->get('email','','username');
		$data->name = $jinput->get('name','','string');
		$data->message = $jinput->get('message','','string');
		

			// Prepare email body
			//$prefix = JText::sprintf('COM_CONTACT_ENQUIRY_TEXT', JUri::base());
			$prefix = 'Hello Friend';
			$body   = $prefix . "\n" . $data->name . ' <' . $data->email . '>' .' send message '.$data->message. "\r\n\r\n" . stripslashes($body);

			$mail = JFactory::getMailer();
			$mail->addRecipient($data->email);
		//	$mail->addReplyTo($email, $name);
			$mail->setSender(JText::_('COM_CCINVE_EMAIL_SENDER'));
			
			$mail->setSubject(JText::_('COM_CCINVE_EMAIL_SUBJECT'));
			$mail->setBody($body);
			$sent = $mail->Send();

			return $sent;
	}
		
		
}