<?php
defined('_JEXEC') or die;

use Joomla\CMS\Component\Router\RouterBase;

class CCauthRouter extends RouterBase
{
	 
	public function build(&$query)
	{
		$segments = array();

		if (isset($query['view']))
		{
			$segments[] = $query['view']; //count 0
			unset($query['view']);
		}
		
		if (isset($query['uscode']))//authority checker
		{
			switch($segments[0])
			{
				case 'home':
					$segments[] = $query['uscode']; //count 3
					break;
					
				case 'chgpas':
					$segments[] = $query['uscode']; //count 3
					break;
					
				case 'new_sale':
					$segments[] = $query['uscode']; //count 3
					break;		
					
				case 'new_prod':
					$segments[] = $query['uscode']; //count 3
					break;	
					
				case 'siap_kirim':
					$segments[] = $query['uscode']; //count 3
					break;
					
				case 'kirim_fwd':
					$segments[] = $query['uscode']; //count 3
					break;
					
				case 'konfirmasi':
					$segments[] = $query['uscode']; //count 3
					break;
					
				case 'sale_list':
					$segments[] = $query['uscode']; //count 3
					break;
					
				case 'prod_list':
					$segments[] = $query['uscode']; //count 3
					break;
									
				case 'proddetail':
					$segments[] = $query['uscode']; //count 3
					break;
				case 'produpdate':
					$segments[] = $query['uscode']; //count 3
					break;
	//************				Versi 1.03 Inventory
				case 'inve_list':
					$segments[] = $query['uscode']; //count 3
					break;
				case 'invemaintain':
					$segments[] = $query['uscode']; //count 3
					break;
				case 'stock_list':
					$segments[] = $query['uscode']; //count 3
					break;
				case 'new_inve':
					$segments[] = $query['uscode']; //count 3
					break;
				case 'collectlist':
					$segments[] = $query['uscode']; //count 3
					break;
				case 'collectdetail':
					$segments[] = $query['uscode']; //count 3
					break;	//************				Versi 1.03 Inventory
	//***** versi 1.04 Users and Menu Management 
	
				case 'user_list':
				$segments[] = $query['uscode']; //count 3
				break;
				case 'user_details':
				$segments[] = $query['uscode']; //count 3
				break;	

	
				}
			unset($query['uscode']);
		}
		
	   if (isset($query['skey']))//authority checker
		{
			switch($segments[0])
			{
				case 'home':
					$segments[] = $query['skey']; //count 4
					break;
					
				case 'chgpas':
					$segments[] = $query['skey']; //count 4
					break;
					
				case 'new_sale':
					$segments[] = $query['skey']; //count 4
					break;		
					
				case 'new_prod':
					$segments[] = $query['skey']; //count 4
					break;			
					
				case 'siap_kirim':
					$segments[] = $query['skey']; //count 3
					break;
					
				case 'kirim_fwd':
					$segments[] = $query['skey']; //count 3
					break;
					
				case 'konfirmasi':
					$segments[] = $query['skey']; //count 3
					break;
					
				case 'sale_list':
					$segments[] = $query['skey']; //count 3
					break;
				case 'prod_list':
					$segments[] = $query['skey']; //count 3
					break;
				case 'proddetail':
					$segments[] = $query['skey']; //count 3
					break;
				case 'produpdate':
					$segments[] = $query['skey']; //count 3
					break;
	//************				Versi 1.03 Inventory
				case 'inve_list':
					$segments[] = $query['skey']; //count 3
					break;
				case 'stock_list':
					$segments[] = $query['skey']; //count 3
					break;
				case 'invemaintain':
					$segments[] = $query['skey']; //count 3
					break;
				case 'new_inve':
					$segments[] = $query['skey']; //count 3
					break;
				case 'collectlist':
					$segments[] = $query['skey']; //count 3
					break;
				case 'collectdetail':
					$segments[] = $query['skey']; //count 3
					break;
					//************				Versi 1.03 Inventory
			}
			unset($query['skey']);
		}
		

	if (isset($query['month']))//only for sales list
		{
			switch($segments[0])
			{
				case 'sale_list':
					$segments[] = $query['month']; //count 3
					break;
				case 'prod_list':
					$segments[] = $query['month']; //count 3
					break;
			}
			unset($query['month']);
		}

	if (isset($query['salesid']))//only for detail items
		{
			switch($segments[0])
			{							
				case 'siap_kirim':
					$segments[] = $query['salesid']; //count 3
					break;
					
				case 'kirim_fwd':
					$segments[] = $query['salesid']; //count 3
					break;
					
				case 'konfirmasi':
					$segments[] = $query['salesid']; //count 3
					break;
			}
			unset($query['salesid']);
		}

	if (isset($query['id']))//only for detail items
		{
			switch($segments[0])
			{							
				case 'proddetail':
					$segments[] = $query['id']; //count 3
					break;
				case 'produpdate':
					$segments[] = $query['id']; //count 3
					break;

					
				case 'invemaintain':
					$segments[] = $query['id']; //count 3
					break;
				case 'stock_list':
					$segments[] = $query['id']; //count 3
					break;
				case 'collectdetail':
					$segments[] = $query['id']; //count 3
					break;
			}
			unset($query['id']);
		}
		
	if (isset($query['routing']))//only for detail items
		{
			switch($segments[0])
			{							
				case 'logon':
					$segments[] = $query['routing']; //count 1
					break;
			}
			unset($query['routing']);
		}

	return $segments;
	}
	
	function parse(&$segments)
	{  
	   $vars = array();
	   //default 1 and 2 are checked for uscode and skey
	   if (isset($segments[1])){
				$vars['uscode'] =  $segments[1];
				}
				else{
				$vars['uscode'] =  '';
				}
		if (isset($segments[2])){
				$vars['skey'] =  $segments[2];
				}
				else{
				$vars['skey'] =  '';
				}

	   switch($segments[0])
	   {
			case 'home':
			    $vars['view'] = 'home';
                break;
				
			case 'chgpas':
			    $vars['view'] = 'chgpas';
                break;
				
			case 'logon':
			    $vars['view'] = 'logon';
				if (isset($segments[1])){
					$vars['routing'] = $segments[1];
				}
                break;
				
			case 'new_sale':
			    $vars['view'] = 'new_sale';
                break;	
				
			case 'new_prod':
			    $vars['view'] = 'new_prod';
                break;				
				
			case 'sale_list':
			    $vars['view'] = 'sale_list';
				if (isset($segments[3])){
					$vars['month'] = $segments[3];
				}
                break;
				
			case 'prod_list':
			    $vars['view'] = 'prod_list';
				if (isset($segments[3])){
					$vars['month'] = $segments[3];
				}
                break;

			case 'proddetail':
			    $vars['view'] = 'proddetail';
				if (isset($segments[3])){
					$vars['id'] = $segments[3];
				}
			case 'produpdate':
			    $vars['view'] = 'produpdate';
				if (isset($segments[3])){
					$vars['id'] = $segments[3];
				}
                break;
				
			case 'siap_kirim':
			    $vars['view'] = 'siap_kirim';
				if (isset($segments[3])){
					$vars['salesid'] =  $segments[3];
				}
                break;			
				
			case 'kirim_fwd':
			    $vars['view'] = 'kirim_fwd';
				if (isset($segments[3])){
					$vars['salesid'] =  $segments[3];
				}
                break;			
				
			case 'konfirmasi':
			    $vars['view'] = 'konfirmasi';
				if (isset($segments[3])){
					$vars['salesid'] =  $segments[3];
				}
				break;			
	//************				Versi 1.03 Inventory
					
				case 'invemaintain':
					$vars['view'] = 'invemaintain';
				if (isset($segments[3])){
					$vars['id'] =  $segments[3];
					}					
				break;
				
				case 'inve_list':
					$vars['view'] = 'inve_list';
				break;
				
				case 'stock_list':
					$vars['view'] = 'stock_list';
					if (isset($segments[3])){
						$vars['id'] =  $segments[3];
					}
				break;
				
				case 'collectdetail':
					$vars['view'] = 'collectdetail';
					if (isset($segments[3])){
						$vars['id'] =  $segments[3];
					}
				break;
				
				case 'new_inve':
					$vars['view'] = 'new_inve';
				break;
				case 'collectlist':
					$vars['view'] = 'collectlist';
				break;

	
				
	//************				Versi 1.03 Inventory
				
		}
		
       return $vars;
	}
}
