<?php
/**
 *  
 * support: sorting configured in menu items.
 * numbering on item, numbering on page, max item per page, max paging per page.
 */
 
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

class CCauthModelCollectdetail extends JModelItem
{
	protected $messages;

	public function sanitizeInput($input){
		$input = trim($input);
		$input = stripslashes($input);
		$input = htmlspecialchars($input);
		return $input;
		}
	
	public function validateCompare($data, $validData){
		//This function to compare a string against valid data in arrays.
		$data = $this->sanitizeInput($data);
		//set default first
		$result = $validData[0];// set default result to first valid data if not found
		//compare, if found override result
			foreach ($validData as $testdata){
				if($testdata == $data ){				
				$result = $data; //override result
				}
			}
		return $result;
		}

//function to validate user
	public function getUsid($passwd, $uscode, $priv_req) {
			$db = JFactory::getDbo();
			$query = $db->getQuery(true);
			$query->select($db->quoteName('a.uscode')); //change field
			$query->from($db->quoteName('#__ccauthsession', 'a')); // change when change table
			$query->join('RIGHT', $db->quoteName('#__ccauthlist', 'b') . ' ON (' . $db->quoteName('a.uscode') . ' = ' . $db->quoteName('b.uscode') . ')');
			// here is the matching criteria:  
			$query->where($db->quoteName('passwrd') . ' = '. $db->quote($passwd));
			$query->where($db->quoteName('b.priv') . ' = '. $db->quote($priv_req));//this is the privilege
			$query->where($db->quoteName('b.uscode') . ' = '. $db->quote($uscode));//this is the privilege

			$db->setQuery($query);
			$results = $db->loadResult(); //single data query
			
			return $results;
	}


//function to check if user has access to this view.
	public function getAuth($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$skey = $jinput->get('skey','','string'); //default page is empty.
		$uscode = $jinput->get('uscode','','string'); //default page is empty.
		$priv_req = 'konfirmasi'; //required privilege
				
		//validation process
		$skey = $this->sanitizeInput($skey);
			
		// query if found

			
		//$check = getUsid($skey, $uscode, $priv_req);
		$check = $this->getUsid($skey, $uscode, $priv_req);
		
		if($check!=""){
			$valid = 1;
			}
			else {
			$valid = 0;
			}
			
		return $valid;
	}
//prepare the sessions, user codes, salesID and month for Menus in the default page.
	
	public function getSkey($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('skey','','string'); //default page is empty.
		//validation process
		$result = $this->sanitizeInput($result);
		return $result;		
	}
	
	public function getUscode($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('uscode','','string'); //default page is empty.
		//validation process
		$result = $this->sanitizeInput($result);
		return $result;		
	}
		public function getPoref($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('id','','string'); //default page is empty.
		//validation process
		$result = $this->sanitizeInput($result);
		return $result;		
	}
	
		
	public function selectRows($fields, $table, $conditions, $orders, $joints1, $table2, $joints2){
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);

		// how to use
		/*
		$fields = array, example: $fields = array('a.*', 'b.username', 'b.name');
		$table1 and table2 = array, table and assigned variable, example $table = ('#__content', 'a');
		$conditions = [0] set the table and operator, [1] tested values, example $conditions = array('b.username', ' = 2');
		*/
		$query->select($fields);
		$query->from($db->quoteName($table));
		
		if(isset($joints1)){
		$query->join('INNER', $db->quoteName($table2) . ' ON ' . $db->quoteName($joints1) . ' = ' . $db->quoteName($joints2));
		}
		
		$query->where($db->quoteName($conditions[0]) . ' = ' . $db->quote($conditions[1]));
		
		if(isset($order)){
		$query->order($db->quoteName($orders[0]) . $orders[1]);
		}

		$db->setQuery($query);

		// Load the results as a list of stdClass objects (see later for more options on retrieving data).
		$results = $db->loadObjectList();
	}		
		
	public function getMenus($id = 1){
		//check authority
		$valid = $this->getAuth();//authority check
	
		if($valid == 1){
			if (!isset($this->article[$id]))
			{			
		
			// get from xml
			$jinput = JFACTORY::getApplication()->input;

			//get the ordering
			$app = JFactory::getApplication();
		//	$params = $app->getParams();
		//	$order_type = $this->getOrdering();
			$jinput = JFACTORY::getApplication()->input;
			$skey = $jinput->get('skey','','string'); //default page is empty.
			$uscode = $jinput->get('uscode','','string'); //default page is empty.
	
			$db = JFactory::getDbo();
			
			$query = $db->getQuery(true);		
			$query->select(array('a.uscode', 'a.priv', 'a.id','b.link_to_menu','b.menu','b.menu_desc','b.task','b.option_s'));
			$query->from($db->quoteName('#__ccauthlist', 'a')); // change when change table
			$query->join('LEFT', $db->quoteName('#__ccauthmenu', 'b') . ' ON (' . $db->quoteName('a.priv') . ' = ' . $db->quoteName('b.priv') . ')');
			$query->where($db->quoteName('uscode') . ' = '. $db->quote($uscode));
			$query->where($db->quoteName('b.link_to_menu') . ' != ""');
			$query->where($db->quoteName('b.published') . ' = 1'); // only view the menus, not action privileges.

			// Order it by the ordering field.
			$query->order('id ASC');			
			//$query->setLimit($itemsperpage,$skipitems);

			$db->setQuery($query);
			 
			$results = $db->loadObjectList();	

			}
		}
		if($valid == 0){ //authority check
			$results = array(); // if authority is not valid, give no information at all.
		}
		
		return $results;
	}
	
	public function getSomeRows($selects, $table, $key, $where="", $ins="", $ordering="", $by="") {
		// This function is to get eligible items as arrays.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($selects); //array
		$query->from($db->quoteName($table)); // change when change table
		// here is the matching criteria:  
	 	if($where!=""){
			$query->where($db->quoteName($where) . ' = '. $db->quote($ins));
		}
	 	if($ordering!=""){
			$query->order($ordering.$by);
		}
		$db->setQuery($query);
		$result = $db->loadAssocList();
		
		return $result;
	}
	
	
	////////////// GET DETAILS for THIS PAGE////////////////
	public function getDetails(){	
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select(array('a.id','a.customer','a.collect_ref','a.collect_date','a.eligible','a.remark','a.status')); //array
		$query->from($db->quoteName('#__ccsale_collect', 'a')); // change when change table
		//$query->join('LEFT', $db->quoteName('#__ccwarehousemaster', 'c') . ' ON ' . $db->quoteName('a.warehouse') . ' = ' . $db->quoteName('c.enid'));
		//$query->join('LEFT', $db->quoteName('#__ccitemmaster', 'd') . ' ON ' . $db->quoteName('a.itemcode') . ' = ' . $db->quoteName('d.itemcode'));
		//$query->join('LEFT', $db->quoteName('#__ccpurvendor', 'e') . ' ON ' . $db->quoteName('a.vendor') . ' = ' . $db->quoteName('e.vendorid'));

		// here is the matching criteria:  
		$query->where($db->quoteName('a.active') . ' = 1');	
		$query->where($db->quoteName('a.collect_ref') . ' = '.$db->quote($this->getPoref()));	

	 	$query->order('a.id DESC');
		
		$db->setQuery($query);
		$results = $db->loadObject();

		return $results;
	}
	
	////////////// GET List of the payment done ////////////////
	public function getList(){	
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select(array('a.id', 'a.collect_date','a.payment','d.name as payment_type','a.remark')); //array
		$query->from($db->quoteName('#__ccsale_collect_details', 'a')); // change when change table
		$query->join('LEFT', $db->quoteName('#__ccsale_collect', 'b') . ' ON ' . $db->quoteName('a.collect_ref') . ' = ' . $db->quoteName('b.collect_ref'));
		$query->join('LEFT', $db->quoteName('#__ccpaymentmaster', 'd') . ' ON ' . $db->quoteName('a.payment_type') . ' = ' . $db->quoteName('d.code'));
//		$query->join('LEFT', $db->quoteName('#__ccpurvendor', 'e') . ' ON ' . $db->quoteName('a.vendor') . ' = ' . $db->quoteName('e.vendorid'));

		// here is the matching criteria:  
		$query->where($db->quoteName('a.active') . ' = 1');	
		$query->where($db->quoteName('a.collect_ref') . ' = '.$db->quote($this->getPoref()));	

	 	$query->order('a.id DESC');
		
		$db->setQuery($query);
		$results = $db->loadObjectList();
		
		return $results;
	}
	
	public function getTypes(){	
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select(array('a.code', 'a.name')); //array
		$query->from($db->quoteName('#__ccpaymentmaster', 'a')); // change when change table
		// here is the matching criteria:  
		$query->where($db->quoteName('a.active') . ' = 1');	

	 	$query->order('a.id ASC');
		
		$db->setQuery($query);
		$results = $db->loadObjectList();
		
		return $results;
	}
	
}