<?php
/**
 * COMMENTS v.1.0 December 2015
 * to see COMMENTS on CERTAIN ARTICLES.
 * 
 * support: sorting configured in menu items.
 * numbering on item, numbering on page, max item per page, max paging per page.
 */
 
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

class CCauthModelProdupdate extends JModelItem
{
	protected $messages;

/*
	public function getTable($type = 'CCinve', $prefix = 'CcInveTable', $config = array()) //cc notes: prefix can be changed consistent with file ccworld content. Type should consistent with both class name and file name.
	{
		return JTable::getInstance($type, $prefix, $config);
	}
*/ 

	public function sanitizeInput($input){
		$input = trim($input);
		$input = stripslashes($input);
		$input = htmlspecialchars($input);
		return $input;
		}
	
	public function validateCompare($data, $validData){
		//This function to compare a string against valid data in arrays.
		$data = $this->sanitizeInput($data);
		//set default first
		$result = $validData[0];// set default result to first valid data if not found
		//compare, if found override result
			foreach ($validData as $testdata){
				if($testdata == $data ){				
					$result = $data; //override result
				}
			}
		return $result;
		}

//function to validate user
	public function getUsid($passwd, $uscode, $priv_req) {
			$db = JFactory::getDbo();
			$query = $db->getQuery(true);
			$query->select($db->quoteName('a.uscode')); //change field
			$query->from($db->quoteName('#__ccauthsession', 'a')); // change when change table
			$query->join('RIGHT', $db->quoteName('#__ccauthlist', 'b') . ' ON (' . $db->quoteName('a.uscode') . ' = ' . $db->quoteName('b.uscode') . ')');
			// here is the matching criteria:  
			$query->where($db->quoteName('passwrd') . ' = '. $db->quote($passwd));
			$query->where($db->quoteName('b.priv') . ' = '. $db->quote($priv_req));//this is the privilege
			$query->where($db->quoteName('b.uscode') . ' = '. $db->quote($uscode));//this is the privilege

			$db->setQuery($query);
			$results = $db->loadResult(); //single data query
			
			return $results;
	}

	public function getAuthChange($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$skey = $jinput->get('skey','','string'); //default page is empty.
		$uscode = $jinput->get('uscode','','string'); //default page is empty.
		$priv_req = 'prodchange'; //required privilege
				
		//validation process
		$skey = $this->sanitizeInput($skey);
			
		// query if found

			
		//$check = getUsid($skey, $uscode, $priv_req);
		$check = $this->getUsid($skey, $uscode, $priv_req);
		
		if($check!=""){
			$valid = 1;
			}
			else {
			$valid = 0;
			}
			
		return $valid;
	}
	public function getAuthUpdate($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$skey = $jinput->get('skey','','string'); //default page is empty.
		$uscode = $jinput->get('uscode','','string'); //default page is empty.
		$priv_req = 'produpdate'; //required privilege
				
		//validation process
		$skey = $this->sanitizeInput($skey);
			
		// query if found

			
		//$check = getUsid($skey, $uscode, $priv_req);
		$check = $this->getUsid($skey, $uscode, $priv_req);
		
		if($check!=""){
			$valid = 1;
			}
			else {
			$valid = 0;
			}
			
		return $valid;
	}

//function to check if user has access to this view.
	public function getAuth($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$skey = $jinput->get('skey','','string'); //default page is empty.
		$uscode = $jinput->get('uscode','','string'); //default page is empty.
		$priv_req = 'konfirmasi'; //required privilege
				
		//validation process
		$skey = $this->sanitizeInput($skey);
			
		// query if found

			
		//$check = getUsid($skey, $uscode, $priv_req);
		$check = $this->getUsid($skey, $uscode, $priv_req);
		
		if($check!=""){
			$valid = 1;
			}
			else {
			$valid = 0;
			}
			
		return $valid;
	}
//prepare the sessions, user codes, salesID and month for Menus in the default page.
	
	public function getSkey($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('skey','','string'); //default page is empty.
		//validation process
		$result = $this->sanitizeInput($result);
		return $result;		
	}
	
	public function getUscode($id = "") {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('uscode','','string'); //default page is empty.
		//validation process
		$result = $this->sanitizeInput($result);
		return $result;		
	}
	public function getId($id = "") {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('id','','string'); //default page is empty.
		//validation process
		$result = $this->sanitizeInput($result);
		return $result;		
	}
	
	public function getMonth($id = "") {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('month','','string'); //default page is empty.
		//validation process
		$result = $this->sanitizeInput($result);
		return $result;		
	}
		
	public function getEmpl() {		//authority check
			$results = $this->getInstance('Home', 'CCauthModel')-> get_things(array('alias', 'name'), 'ccempl', 'status', 1);
			$pairs = array();
			$i = 0;
			foreach ($results as $result){
			$pairs[$i] = $result->alias .'-'.$result->name;
			$i++;
			}
			return $pairs;
	}
	
	public function getItemcode($id = "") {		//authority check
			$results = $this->getInstance('Home', 'CCauthModel')-> get_things(array('itemcode', 'itemdesc'), 'ccsalesmaster', 'status', 1);
			$pairs = array();
			foreach ($results as $result){
				$pairs[] = $result->itemcode .'-'.$result->itemdesc;
			}
			return $pairs;
	}

	
//Prepare some parameters to display main messages / list of messages.
	public function getPage($id = 1) {		
		$jinput = JFACTORY::getApplication()->input;
		$page = $jinput->get('page',1,'int'); //default page is 1.
				
		//validation process
		$page = $this->sanitizeInput($page);
		$itemscount = $this->getItemscount();
		$itemsperpage = $this->getItemsperpage();
			
		// get from xml
		$maxpage = round(($itemscount / $itemsperpage) + 0.5,0,PHP_ROUND_HALF_DOWN);
		
		if($page < 1){$page = 1;}//default page is 1.
		if($page > $maxpage){$page = $maxpage;} //max is maxpage
		return $page;
	}

	
//get current maximum paging per screen.
	public function getMaxpaging($id = 1){
		// get from xml
		$app = JFactory::getApplication();
		$params = $app->getParams();
				
		$result = $params->get('maxpage', 10); //if not set, then 10 as default
		return $result;			
	}

//count number of messages / items matching criteria, so it can be calculated for paging.
	public function getItemscount($id = 1) {
		// This function is to count eligible items. Results are returned to get the max page.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		
		$months = $this->getMonth();

		$db = JFactory::getDbo();
		$query = $db->getQuery(true);

		// how to use
		/*
		$fields = array, example: $fields = array('a.*', 'b.username', 'b.name');
		$table1 and table2 = array, table and assigned variable, example $table = ('#__content', 'a');
		$conditions = [0] set the table and operator, [1] tested values, example $conditions = array('b.username', ' = 2');
		*/
		$query->select('a.*','b.name');
		$query->from($db->quoteName('#__ccsales','a'));
		
		$query->join('INNER', $db->quoteName('#__cccust','b') . ' ON ' . $db->quoteName('a.cuid') . ' = ' . $db->quoteName('b.cuid'));
		
		$query->where($db->quoteName('a.published') . ' > ' . $db->quote('0'));
		
		$query->where($db->quoteName('a.samonth') . ' = ' . $db->quote($months) );
		$query->order($db->quoteName('a.salesid'). ' ASC');
		
		$db->setQuery($query);

		// Load the results as a list of stdClass objects (see later for more options on retrieving data).
		$results = $db->loadObjectList();
		
		$itemscount = count($results);
		
	// jadul
	/*
		$query->select($db->quoteName('a.uscode'));
		$query->select($db->quoteName('a.priv'));
		$query->select($db->quoteName('b.link_to_menu'));
		$query->select($db->quoteName('b.menu'));
		$query->select($db->quoteName('b.menu_desc'));
		$query->from($db->quoteName('#__ccauthlist', 'a')); // change when change table
		$query->join('LEFT', $db->quoteName('#__ccauthmenu', 'b') . ' ON (' . $db->quoteName('a.priv') . ' = ' . $db->quoteName('b.priv') . ')');
		$query->where($db->quoteName('uscode') . ' = '. $db->quote($uscode));
		$query->where($db->quoteName('b.link_to_menu') . ' != ""');
		
		$db->setQuery($query);
			 
		$results = $db->loadObjectList();	
		$itemscount = count($results);
		*/
	//	jadul
		return $itemscount;
		}
	
		
//get numbers of messages/items shown per page.
	public function getItemsperpage(){

		// get from xml if database is not set
		$app = JFactory::getApplication();
		$params = $app->getParams();
				
		$result = $params->get('maxitem',10); //if not set, 10 as default
		
		return $result;
		}

// now get the comments to be displayed, according to matching criteria.
	
	public function getOrdering($id = 1) {	
			$app = JFactory::getApplication();
			$params = $app->getParams();
			$order_default = $app->input->get('limit', $params->get('orderby_sec', 'inid'), 'uint');
			
			//new: override if set by user. dont forget to validate
			$jinput = JFACTORY::getApplication()->input;
			$order_type = $jinput->get('orderby',$order_default); //default get parameter

			$order_submit = $this->sanitizeInput($jinput->get('ordering_submit')); 
			if (isset($order_submit))
			{
			$order_type = $order_submit;
			}
			$validDataOrdering = ['id','rid','name','rname'];
			
			$order_type = $this->validateCompare($order_type, $validDataOrdering);
						
			return $order_type;
		}
		
	public function selectRows($fields, $table, $conditions, $orders, $joints1, $table2, $joints2){
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);

		// how to use
		/*
		$fields = array, example: $fields = array('a.*', 'b.username', 'b.name');
		$table1 and table2 = array, table and assigned variable, example $table = ('#__content', 'a');
		$conditions = [0] set the table and operator, [1] tested values, example $conditions = array('b.username', ' = 2');
		*/
		$query->select($fields);
		$query->from($db->quoteName($table));
		
		if(isset($joints1)){
		$query->join('INNER', $db->quoteName($table2) . ' ON ' . $db->quoteName($joints1) . ' = ' . $db->quoteName($joints2));
		}
		
		$query->where($db->quoteName($conditions[0]) . ' = ' . $db->quote($conditions[1]));
		
		if(isset($order)){
		$query->order($db->quoteName($orders[0]) . $orders[1]);
		}

		$db->setQuery($query);

		// Load the results as a list of stdClass objects (see later for more options on retrieving data).
		$results = $db->loadObjectList();
	}		
		
	public function getMenus($id = 1){
		//check authority
		$valid = $this->getAuth();//authority check
	
		if($valid == 1){
			if (!isset($this->article[$id]))
			{					
			// get from xml
			$jinput = JFACTORY::getApplication()->input;

			//get the ordering
			$app = JFactory::getApplication();
		//	$params = $app->getParams();
		//	$order_type = $this->getOrdering();
			$jinput = JFACTORY::getApplication()->input;
			$skey = $jinput->get('skey','','string'); //default page is empty.
			$uscode = $jinput->get('uscode','','string'); //default page is empty.
			 
			// Create a new query object.
			
			$db = JFactory::getDbo();
			
			$query = $db->getQuery(true);		
			
			$query->select($db->quoteName('a.uscode'));
			$query->select($db->quoteName('a.priv'));
			$query->select($db->quoteName('a.id'));
			$query->select($db->quoteName('b.link_to_menu'));
			$query->select($db->quoteName('b.menu'));
			$query->select($db->quoteName('b.menu_desc'));
			$query->select($db->quoteName('b.task'));
			$query->select($db->quoteName('b.option_s'));
			$query->from($db->quoteName('#__ccauthlist', 'a')); // change when change table
			$query->join('LEFT', $db->quoteName('#__ccauthmenu', 'b') . ' ON (' . $db->quoteName('a.priv') . ' = ' . $db->quoteName('b.priv') . ')');
			$query->where($db->quoteName('uscode') . ' = '. $db->quote($uscode));
			$query->where($db->quoteName('b.link_to_menu') . ' != ""');
			$query->where($db->quoteName('b.published') . ' = 1'); // only view the menus, not action privileges.

			// Order it by the ordering field.
			$query->order('id ASC');			
			//$query->setLimit($itemsperpage,$skipitems);

			$db->setQuery($query);
			 
			$results = $db->loadObjectList();	
			}
		}
		if($valid == 0){ //authority check
			$results = array(); // if authority is not valid, give no information at all.
		}
		return $results;
	}
	
	public function getInves(){
		$id	= $this->getId();

		$db = JFactory::getDbo();
			
		$query = $db->getQuery(true);		
		$query->select(array('a.itemcode','a.available','a.incoming_req','a.incoming_com','a.incoming_del','a.incoming_con'));
		$query->from($db->quoteName('#__ccwarehouse', 'a')); // change when change table	
		
		$query->where($db->quoteName('enid') . ' = '. $db->quote($id));

		$db->setQuery($query);
		 
		$results = $db->loadAssocList('itemcode');
		return $results;
	}
	
	public function getNames(){
		$db = JFactory::getDbo();
			
		$query = $db->getQuery(true);		
		$query->select(array('a.id','a.name'));
		$query->from($db->quoteName('#__ccsalesmaster', 'a')); // change when change table	
		
		$db->setQuery($query);
		 
		$results = $db->loadAssocList('id');
		return $results;
	}
	
	public function getMoves(){
		$db = JFactory::getDbo();
		$id	= $this->getId();

		$query = $db->getQuery(true);		
		$query->select(array('id','startdate','duedate','movtype','itemcode', 'usid', 'entityfrom','entityto','quantity','status'));
		$query->from($db->quoteName('#__ccinvemov')); // change when change table			
		$query->where($db->quoteName('entityto') . ' = '. $db->quote($id), 'OR');
		$query->where($db->quoteName('entityfrom') . ' = '. $db->quote($id));
		$query->order('itemcode ASC, startdate DESC');			 
		$db->setQuery($query);
		$results = $db->loadObjectList('id');
		return $results;
	}
	
	public function getMsg($id = 1){
		$valid = $this->getAuth();//authority check
	
		if($valid == 1){
			
			$itemsperpage = $this->getItemsperpage();
						
			$skey 	= $this->getSkey(); 
			$uscode = $this->getUscode(); 	
			$id		= $this->getId();
			
			$db = JFactory::getDbo();
			
			$msg = $db->getQuery(true);		
			$msg->select(array('a.*', 'c.bom as bom', 'c.itemcode','c.itemdesc as productname', 'b.alias', 'b.name as picname'));

	//		$msg->select($db->quoteName('b.ponumber'));
			$msg->from($db->quoteName('#__ccprodlist', 'a')); // change when change table
			$msg->join('LEFT', $db->quoteName('#__ccempl', 'b') . ' ON (' . $db->quoteName('a.pic') . ' = ' . $db->quoteName('b.alias') . ')');
			$msg->join('LEFT', $db->quoteName('#__ccsalesmaster', 'c') . ' ON (' . $db->quoteName('a.itemcode') . ' = ' . $db->quoteName('c.itemcode') . ')');
			$msg->where($db->quoteName('a.id') . ' = '. $db->quote($id));
			//$msg->where($db->quoteName('c.status') . ' = 1');

			//$msg->where($db->quoteName('b.link_to_menu') . ' != ""');
			// Order it by the ordering field.
			$msg->order('id ASC');			
			$db->setQuery($msg);
			$results = $db->loadObject();	
	
		}
		if($valid == 0){ //authority check
			$results = array();
		}
			return $results;
	}
}