<?php
// No direct access to this file

// No direct access to this file
defined('_JEXEC') or die('Restricted access');
 
/**
 * HTML View class for the HelloWorld Component
 *
 * @since  0.0.1
 */
class CCjournalViewMessages extends JViewLegacy //change component
{
function display($tpl = null)
	{
		// Assign data to the view
		$this->rows = $this->get('Msg'); //cc notes: this->msg is to be passed to layout. get('Msg') is the model
		$this->page = $this->get('Page'); // current page
		$this->order = $this->get('Ordering'); // new - get the ordering
	
		$this->auth = $this->get('Auth');
		$this->skey = $this->get('Skey');

		//get number of items
		$this->itemscount = $this->get('Itemscount');
		//get number of items per page
		$this->itemsperpage = $this->get('Itemsperpage');
		//get max number of pagination shown
		$this->maxpaging = $this->get('Maxpaging');
				
		// paging start: ((round down (current page divided by paging per screen)) * paging per screen) + 1
		$this->paging_start = ((round(($this->page / $this->maxpaging) - 0.5,0,PHP_ROUND_HALF_DOWN)) * $this->maxpaging) + 1;
		// paging end before comparison
		$this->paging_end = $this->paging_start + $this->maxpaging - 1;
		// if actual paging end is less, then override the paging end
		$this->actual_max = round($this->itemscount / $this->itemsperpage + 0.5, 0, PHP_ROUND_HALF_DOWN);
		if ($this->paging_end > $this->actual_max){
		$this->paging_end = $this->actual_max;
		}
		//next paging
		
		
		//numbering start
		$this->numbering_start = (($this->page - 1) * $this->itemsperpage ) + 1;
		//numbering end
		$this->numbering_end = $this->numbering_start + $this->itemsperpage - 1;
		if($this->numbering_end > $this->itemscount){
			$this->numbering_end = $this->itemscount;
		}
		
		
		// Pages_Counter -- method to show to display "showing start - end of end of items"
		if($this->numbering_start == $this->numbering_end){
		$this->pages_counter = 'Showing '.$this->numbering_start.' of '.$this->itemscount;
		}
		else{
		$this->pages_counter = 'Showing '.$this->numbering_start.' - '.$this->numbering_end.' of '.$this->itemscount;
		}
		
		// Check for errors.
		if (count($errors = $this->get('Errors')))
		{
			JLog::add(implode('<br />', $errors), JLog::WARNING, 'jerror');
			return false;
		}
		// Display the view
		parent::display($tpl);
	}
	
}
?>