<?php

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport('joomla.application.component.model');

class CCauthModelNew_Sale extends JModelItem
{
	//to get back the id of article want to be commented.
	
	//new pisahkan getUsid


//validate the user first
	public function checkAuth() 
	{	
		$jinput = JFACTORY::getApplication()->input;
		
		$skey 	= $this->getSkey(); 
		$uscode = $this->getUscode(); 
		$priv_req = 'authall'; //required privilege
						
		//query if found
		//$check = $this->compare_privilege($skey, $uscode, $priv_req);
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName('a.uscode')); 
		$query->from($db->quoteName('#__ccauthsession', 'a')); 
		$query->join('RIGHT', $db->quoteName('#__ccauthlist', 'b') . ' ON (' . $db->quoteName('a.uscode') . ' = ' . $db->quoteName('b.uscode') . ')');
		// here is the matching criteria:  
		$query->where($db->quoteName('passwrd') . ' = '. $db->quote($skey));
		$query->where($db->quoteName('b.priv') . ' = '. $db->quote($priv_req));//this is the privilege
		$query->where($db->quoteName('b.uscode') . ' = '. $db->quote($uscode));//this is the privilege

		$db->setQuery($query);
		$check = $db->loadResult(); //single data query
		
		if($check != "")
		{
			$valid = 1;
		} else {
			$valid = 0;
		}	
		return $valid;
	}

	public function getUsid($passwd, $uscode, $priv_req) {

		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName('a.uscode')); //change field
		$query->from($db->quoteName('#__ccauthsession', 'a')); // change when change table
		$query->join('RIGHT', $db->quoteName('#__ccauthlist', 'b') . ' ON (' . $db->quoteName('a.uscode') . ' = ' . $db->quoteName('b.uscode') . ')');
		// here is the matching criteria:  
		$query->where($db->quoteName('passwrd') . ' = '. $db->quote($passwd));
		$query->where($db->quoteName('b.priv') . ' = '. $db->quote($priv_req));//this is the privilege
		$query->where($db->quoteName('b.uscode') . ' = '. $db->quote($uscode));//this is the privilege

		$db->setQuery($query);
		$results = $db->loadResult(); //single data query
		
		return $results;
	}

	public function getValue($field, $table, $where, $value, $ordering, $by)
	{
		$db = JFactory::getDbo();
		$query = $db
			->getQuery(true)
			->select($field)
			->from($db->quoteName($table))
			->where($db->quoteName($where) . " = " . $db->quote($value))
			->order($db->quoteName($ordering) . $by);
		$db->setQuery($query);
		return $db->loadResult();
	}
	
	public function getLastID()
	{
		return $this->getValue('id', '#__ccsalesdetail', 'published', 1, 'id', ' DESC');
	}

	//validate the user first
	public function getAuth($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$skey = $jinput->get('skey','','string'); //default page is empty.
		$uscode = $jinput->get('uscode','','string'); //default page is empty.
		$priv_req = 'authall'; //required privilege
				
		//validation process
		$skey = $this->sanitizeInput($skey);
			
		//$check = getUsid($skey, $uscode, $priv_req);
		$check = $this->getUsid($skey, $uscode, $priv_req);
		
		if($check!=""){
			$valid = 1;
			}
			else {
			$valid = 0;
			}
		return $valid;
	}
	//prepare the sessions and user-ID
	
	public function getSkey($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('skey','','string'); //default page is empty.
		//validation process
		$result = $this->sanitizeInput($result);
		return $result;		
	}
	
	public function getUscode($id = 1) {		//authority check
		$jinput = JFACTORY::getApplication()->input;
		$result = $jinput->get('uscode','','string'); //default page is empty.
		//validation process
		$result = $this->sanitizeInput($result);
		return $result;		
	}
//prepare the sessions and user-ID - end

	public function sanitizeInput($input){
	$input = trim($input);
	$input = stripslashes($input);
	$input = htmlspecialchars($input);
	return $input;
	}
	
	public function validateCompare($data, $validData){
	//This function to compare a string against valid data in arrays.
	$data = $this->sanitizeInput($data);
	//set default first
	$result = $validData[0];// set default result to first valid data if not found
	//compare, if found override result
		foreach ($validData as $testdata){
			if($testdata == $data ){				
			$result = $data; //override result
			}
		}
	return $result;
	}

function getItemcode($id=1)
	{
		
		//check authority first
		$valid = $this->checkAuth();//authority check first
	
		if($valid == 1){
		// This function is to get eligible items as arrays.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName(array('itemcode','name','price'))); //change field
		$query->from($db->quoteName('#__ccsalesmaster')); // change when change table
		// here is the matching criteria:  
		$query->where($db->quoteName('status') . ' = '. $db->quote('1'));
		 
		$db->setQuery($query);
		$results = $db->loadRowList();
		
		} else{
			$results = array();
		}
		
		return $results;
	}

	function getCuid($id=1)
	{
		//check authority first
		$valid = $this->checkAuth();//authority check first
	
		if($valid == 1){
		
		// This function is to get eligible items as arrays.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName(array('cuid','name'))); //change field
		$query->from($db->quoteName('#__cccust')); // change when change table
		// here is the matching criteria:  
		$query->where($db->quoteName('status') . ' = '. $db->quote('1'));
		 
		$db->setQuery($query);
		$results = $db->loadRowList();
		} else{
			$results = array();
		}
		
		return $results;	
	}
	
	function getWarehouse()
	{
		//check authority first
		$valid = $this->checkAuth();//authority check first
	
		if($valid == 1){
		
		// This function is to get eligible items as arrays.
		// Apply restrictions accordingly.
		// No need to apply ordering in the query
		
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select($db->quoteName(array('enid','enname','endesc'))); //change field
		$query->from($db->quoteName('#__ccwarehousemaster')); // change when change table
		// here is the matching criteria:  
		$query->where($db->quoteName('status') . ' = '. $db->quote('1'));
		$query->where($db->quoteName('customer') . ' = '. $db->quote('1'));

		$db->setQuery($query);
		$results = $db->loadRowList();
		} else{
			$results = array();
		}
		
		return $results;	
	}
	
	function getItemcost()
	{
	//this is to get cost from COGS, moving average
	/*
			$db = JFactory::getDbo();
			
			$query = $db->getQuery(true);		
			
			
			$inven = $db->getQuery(true);

			$inven
			->select('a.inid, a.quantity, a.nominal, a.category, b.inname')//id is the identifier to be replaced next
			->select (
			"CASE WHEN " . $db->quoteName('a.category') ." = 1" .
			" THEN " . $db->quoteName('a.nominal') .
			" ELSE " . $db->quoteName('a.nominal') . "* -1 " .
			" END AS " . $db->quoteName ('nomin'))
			->select (
			"CASE WHEN " . $db->quoteName('a.category') ." = 1" .
			" THEN " . $db->quoteName('a.quantity') .
			" ELSE " . $db->quoteName('a.quantity') . "* -1 " .
			" END AS " . $db->quoteName ('stock'))

			->from($db->quoteName('#__ccinvetrx', 'a'))//change database to be refreshed
			->join('LEFT', $db->quoteName('#__ccinve', 'b') . ' ON (' . $db->quoteName('b.inid') . ' = ' . $db->quoteName('a.inid') . ')')
			->where($db->quoteName('a.status') . ' = 1') //active only
			->where($db->quoteName('a.movdate') .' <= 20191231');//. $cutoffdate) // new with cutoff
			
			$query // only GL with numbers is shown. 
			->select('c.*, SUM(nomin) as nomin, SUM(stock) as stock')
			->from( '('.$inven.') as c')
			->group('c.inid ASC');

			$results = $db->setQuery($query)->loadObjectList();	
			return $results;
			*/
	}

	public function getMenus($id = 1)
		{
		//check authority
		$valid = $this->checkAuth();//authority check first
	
		if($valid == 1){
			if (!isset($this->article[$id]))
			{			
		
			// get from xml
			$jinput = JFACTORY::getApplication()->input;

			//get the ordering
			$app = JFactory::getApplication();
			$params = $app->getParams();
			//$order_type = $this->getOrdering();
			$jinput = JFACTORY::getApplication()->input;
			$skey = $jinput->get('skey','','string'); //default page is empty.
			$uscode = $jinput->get('uscode','','string'); //default page is empty.
	
			// Create a new query object.
			
			$db = JFactory::getDbo();
			
			$query = $db->getQuery(true);		
			
			$query->select($db->quoteName('a.uscode'));
			$query->select($db->quoteName('a.priv'));
			$query->select($db->quoteName('a.id'));
			$query->select($db->quoteName('b.link_to_menu'));
			$query->select($db->quoteName('b.menu'));
			$query->select($db->quoteName('b.menu_desc'));
			$query->select($db->quoteName('b.task'));
			$query->select($db->quoteName('b.option_s'));
			$query->from($db->quoteName('#__ccauthlist', 'a')); // change when change table
			$query->join('LEFT', $db->quoteName('#__ccauthmenu', 'b') . ' ON (' . $db->quoteName('a.priv') . ' = ' . $db->quoteName('b.priv') . ')');
			$query->where($db->quoteName('uscode') . ' = '. $db->quote($uscode));
			$query->where($db->quoteName('b.link_to_menu') . ' != ""');
			$query->where($db->quoteName('b.published') . ' = 1'); // only view the menus, not action privileges.

			// Order it by the ordering field.
			$query->order('id ASC');
			$db->setQuery($query);			 
			$results = $db->loadObjectList();	
			}
		}
		if($valid == 0){ //authority check
			$results = array();
		}
		
		return $results;
	}

	

}
?>