<?php
defined('_JEXEC') or die;

use Joomla\CMS\Component\Router\RouterBase;

class CCpembelianRouter extends RouterBase //change component

{
	public function build(&$query)
	{
		$segments = array();
		
		if (isset($query['view']))
		{
			$segments[] = $query['view']; //count 0
			unset($query['view']);
		}
		
		if (isset($query['uscode']))//authority checker
		{
			switch($segments[0])
			{
				case 'newpur':
					$segments[] = $query['uscode']; //count 1
					break;
					
				case 'purc_list':
					$segments[] = $query['uscode']; //count 1
					break;
					
				case 'purdetail':
					$segments[] = $query['uscode']; //count 1
					break;
					
				case 'purreceive':
					$segments[] = $query['uscode']; //count 1
					break;
														
				case 'purpaylist':
					$segments[] = $query['uscode']; //count 1
					break;	
	
				case 'purpaydetail':
					$segments[] = $query['uscode']; //count 1
					break;	
					
				case 'pur_rec_list':
					$segments[] = $query['uscode']; //count 1
					break;
					
				case 'pur_rec_detail':
					$segments[] = $query['uscode']; //count 1
					break;
					
				case 'pur_ret_new':
					$segments[] = $query['uscode']; //count 1
					break;				

				case 'pur_qc_detail':
					$segments[] = $query['uscode']; //count 1
					break;	

				case 'purretur':
					$segments[] = $query['uscode']; //count 1
					break;		
				case 'warehouse':
					$segments[] = $query['uscode']; //count 1
					break;		
				case 'warehouse_list':
					$segments[] = $query['uscode']; //count 1
					break;							
			}
			unset($query['uscode']);
		}
		
	   if (isset($query['skey']))//authority checker
	   {
			switch($segments[0])
			{
				case 'newpur':
					$segments[] = $query['skey']; //count 1
					break;
					
				case 'purc_list':
					$segments[] = $query['skey']; //count 1
					break;
					
				case 'purdetail':
					$segments[] = $query['skey']; //count 1
					break;
					
				case 'purreceive':
					$segments[] = $query['skey']; //count 1
					break;
					
				case 'purpaylist':
					$segments[] = $query['skey']; //count 1
					break;	
								
				case 'purpaydetail':
					$segments[] = $query['skey']; //count 1
					break;	
				case 'pur_rec_list':
					$segments[] = $query['skey']; //count 1
					break;
					
				case 'pur_rec_detail':
					$segments[] = $query['skey']; //count 1
					break;
					
				case 'pur_ret_new':
					$segments[] = $query['skey']; //count 1
					break;				

				case 'pur_qc_detail':
					$segments[] = $query['skey']; //count 1
					break;	

				case 'purretur':
					$segments[] = $query['skey']; //count 1
					break;		
				case 'warehouse':
					$segments[] = $query['skey']; //count 1
					break;		
				case 'warehouse_list':
					$segments[] = $query['skey']; //count 1
					break;		
			}
			unset($query['skey']);
		}
		
		if (isset($query['poref']))//authority checker
		{
			switch($segments[0])
			{
				case 'purdetail':
					$segments[] = $query['poref']; //count 1
					break;
			}
			unset($query['poref']);
		}
		
		if (isset($query['purid']))//authority checker
		{
			switch($segments[0])
			{
				case 'pur_rec_detail':
					$segments[] = $query['purid']; //count 1
					break;
				case 'purpaydetail':
					$segments[] = $query['purid']; //count 1
					break;
			}
			unset($query['purid']);
		}
  
	return $segments;
	}
	
	function parse(&$segments)
	{  
		$vars = array();
		//default 1 and 2 are checked for uscode and skey
		if (isset($segments[1])){
				$vars['uscode'] =  $segments[1];
				}
				else{
				$vars['uscode'] =  '';
				}
		if (isset($segments[2])){
				$vars['skey'] =  $segments[2];
				}
				else{
				$vars['skey'] =  '';
				}
	   switch($segments[0])
	   {
		   	case 'newpur':
			    $vars['view'] = 'newpur';
			break;
			
		   	case 'purc_list':
			    $vars['view'] = 'purc_list';
			break;
			
		   	case 'purdetail':
			    $vars['view'] = 'purdetail';
				if (isset($segments[3])){
					$vars['poref'] = $segments[3];
				}
			break;
			
		   	case 'purreceive':
			    $vars['view'] = 'purreceive';
			break;
			
		   	case 'pur_rec_list':
			    $vars['view'] = 'pur_rec_list';
			break;
			
		   	case 'pur_rec_detail':
			    $vars['view'] = 'pur_rec_detail';
				if (isset($segments[3])){
					$vars['purid'] = $segments[3];
				}
			break;
			
			case 'purpaylist':
			    $vars['view'] = 'purpaylist';
			break;
			
		   	case 'purpaydetail':
			    $vars['view'] = 'purpaydetail';
				if (isset($segments[3])){
					$vars['purid'] = $segments[3];
				}
			break;			
		   	case 'pur_ret_new':
			    $vars['view'] = 'pur_ret_new';
			break;
			
		   	case 'pur_qc_detail':
			    $vars['view'] = 'pur_qc_detail';
			break;
			
		   	case 'purretur':
			    $vars['view'] = 'purretur';
			break;			
		}
       return $vars;
	}
}
